diff -pruN 1.9.0-3.1/.gitignore 1.11.0-1/.gitignore
--- 1.9.0-3.1/.gitignore	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/.gitignore	2023-11-28 13:07:17.000000000 +0000
@@ -82,3 +82,7 @@ doc/manuals/build
 doc/manuals/vty/ggsn_vty_reference.xml
 
 contrib/osmo-ggsn.spec
+/debian/gtp-echo-responder-dbg/
+/debian/gtp-echo-responder/
+/debian/osmo-ggsn-doc/
+/utils/gtp-echo-responder
diff -pruN 1.9.0-3.1/README.md 1.11.0-1/README.md
--- 1.9.0-3.1/README.md	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/README.md	2023-11-28 13:07:17.000000000 +0000
@@ -27,9 +27,10 @@ There is a web interface at <https://git
 Documentation
 -------------
 
-There currently is no other documentation other than the wiki on the
-homepage.  It would be great if somebody would work towards a user
-manual that can become part of the osmo-gsm-manuals project.
+The user manual and VTY reference are optionally built in PDF form
+as part of the build process. Find pre-rendered versions here:
+
+https://ftp.osmocom.org/docs/osmo-ggsn/master/
 
 Mailing List
 ------------
diff -pruN 1.9.0-3.1/configure.ac 1.11.0-1/configure.ac
--- 1.9.0-3.1/configure.ac	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/configure.ac	2023-11-28 13:07:17.000000000 +0000
@@ -154,9 +154,9 @@ adl_FUNC_GETOPT_LONG
 
 AM_INIT_AUTOMAKE([foreign])
 
-PKG_CHECK_MODULES(LIBOSMOCORE, libosmocore >= 1.7.0)
-PKG_CHECK_MODULES(LIBOSMOVTY, libosmovty >= 1.7.0)
-PKG_CHECK_MODULES(LIBOSMOCTRL, libosmoctrl >= 1.7.0)
+PKG_CHECK_MODULES(LIBOSMOCORE, libosmocore >= 1.9.0)
+PKG_CHECK_MODULES(LIBOSMOVTY, libosmovty >= 1.9.0)
+PKG_CHECK_MODULES(LIBOSMOCTRL, libosmoctrl >= 1.9.0)
 
 AC_ARG_ENABLE(sanitize,
 	[AS_HELP_STRING(
diff -pruN 1.9.0-3.1/contrib/osmo-ggsn.spec.in 1.11.0-1/contrib/osmo-ggsn.spec.in
--- 1.9.0-3.1/contrib/osmo-ggsn.spec.in	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/contrib/osmo-ggsn.spec.in	2023-11-28 13:07:17.000000000 +0000
@@ -30,9 +30,9 @@ BuildRequires:  pkgconfig >= 0.20
 BuildRequires:  systemd-rpm-macros
 %endif
 BuildRequires:  pkgconfig(libgtpnl) >= 1.2.0
-BuildRequires:  pkgconfig(libosmocore) >= 1.7.0
-BuildRequires:  pkgconfig(libosmoctrl) >= 1.7.0
-BuildRequires:  pkgconfig(libosmovty) >= 1.7.0
+BuildRequires:  pkgconfig(libosmocore) >= 1.9.0
+BuildRequires:  pkgconfig(libosmoctrl) >= 1.9.0
+BuildRequires:  pkgconfig(libosmovty) >= 1.9.0
 Obsoletes:      openggsn
 %{?systemd_requires}
 
diff -pruN 1.9.0-3.1/contrib/systemd/osmo-ggsn.service 1.11.0-1/contrib/systemd/osmo-ggsn.service
--- 1.9.0-3.1/contrib/systemd/osmo-ggsn.service	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/contrib/systemd/osmo-ggsn.service	2023-11-28 13:07:17.000000000 +0000
@@ -1,10 +1,13 @@
 [Unit]
 Description=OsmoGGSN
-After=networking.service
+After=network-online.target
+Wants=network-online.target
 
 [Service]
 Type=simple
 Restart=always
+StateDirectory=osmocom
+WorkingDirectory=%S/osmocom
 ExecStart=/usr/bin/osmo-ggsn -c /etc/osmocom/osmo-ggsn.cfg
 RestartSec=2
 RestartPreventExitStatus=1
diff -pruN 1.9.0-3.1/debian/changelog 1.11.0-1/debian/changelog
--- 1.9.0-3.1/debian/changelog	2024-02-29 19:03:22.000000000 +0000
+++ 1.11.0-1/debian/changelog	2024-07-11 20:07:17.000000000 +0000
@@ -1,3 +1,35 @@
+osmo-ggsn (1.11.0-1) experimental; urgency=medium
+
+  [ Nathan Doris ]
+  * debian/*.symbols
+    - refreshed symbols
+
+  * debian/control
+    - added libmnl-dev as dependency to libosmocore
+    - replaced pkg-config with pkgconfig
+    - help2man dependency added for gtp_echo_responder manual page
+
+  * debian/patches/*
+    - refreshed patches
+    - added autotools-pkg-config-macro-not-cross-compilation-safe.patch
+    - added gtp_echo_responder_manual_page.patch
+
+  * debian/copyright
+    - added MIT copyright for gtp files
+    - refreshed debian/* license
+
+  * debian/osmo-ggsn.cfg: removed
+  * debian/osmo-ggsn.install: changed osmo-ggsn.cfg path
+
+  * debian/help2man: new folder
+    - new file: gtp_echo_responder_see_also.h2m
+
+  [ Thorsten Alteholz ]
+  * New upstream release.
+  * debian/control: add Rules-Requires-Root: no
+
+ -- Thorsten Alteholz <debian@alteholz.de>  Thu, 11 Jul 2024 22:07:17 +0200
+
 osmo-ggsn (1.9.0-3.1) unstable; urgency=medium
 
   * Non-maintainer upload.
diff -pruN 1.9.0-3.1/debian/control 1.11.0-1/debian/control
--- 1.9.0-3.1/debian/control	2024-02-29 19:03:22.000000000 +0000
+++ 1.11.0-1/debian/control	2024-07-11 20:07:17.000000000 +0000
@@ -1,17 +1,21 @@
 Source: osmo-ggsn
 Maintainer: Debian Mobcom Maintainers <Debian-mobcom-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>,
-           Ruben Undheim <ruben.undheim@gmail.com>
+           Ruben Undheim <ruben.undheim@gmail.com>,
+           Nate Doris <nate.doris@gmail.com>
 Section: net
 Priority: optional
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
-               pkg-config,
+               pkgconf,
                libdpkg-perl,
-               libosmocore-dev (>= 1.7.0)
-Standards-Version: 4.6.0
+               libosmocore-dev (>= 1.9.2),
+               libmnl-dev,
+               help2man
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian-mobcom-team/osmo-ggsn
 Vcs-Git: https://salsa.debian.org/debian-mobcom-team/osmo-ggsn.git
 Homepage: https://projects.osmocom.org/projects/openggsn
+Rules-Requires-Root: no
 
 Package: osmo-ggsn
 Architecture: any
diff -pruN 1.9.0-3.1/debian/copyright 1.11.0-1/debian/copyright
--- 1.9.0-3.1/debian/copyright	2022-10-15 10:41:32.000000000 +0000
+++ 1.11.0-1/debian/copyright	2024-07-11 20:07:17.000000000 +0000
@@ -17,9 +17,17 @@ Files: lib/getopt.c
 Copyright: 1987-2001 Free Software Foundation, Inc.
 License: LGPL-2.1+
 
+Files: utils/gtp_echo_responder.c
+       utils/gtp_echo_responder_test.py
+Copyright: 2021 sysmocom - s.f.m.c. GmbH <info@sysmocom.de>
+License: MIT
+
 Files: debian/*
 Copyright: 2010-2017  Harald Welte <laforge@gnumonks.org>
-           2016       Ruben Undheim <ruben.undheim@gmail.com>
+           2016-2018  Ruben Undheim <ruben.undheim@gmail.com>
+           2017-2024  Thorsten Alteholz <debian@alteholz.de>
+           2024       Benjamin Drung <bdrung@debian.org> 
+           2024       Nate Doris <nate.doris@gmail.com>
 License: GPL-2
 
 
@@ -56,3 +64,28 @@ License: LGPL-2.1+
  .
  On Debian systems, the complete text of the GNU Lesser General Public
  License version 2.1 can be found in "/usr/share/common-licenses/LGPL-2.1".
+
+License: MIT
+ Copyright (c) 2021 by sysmocom - s.f.m.c. GmbH <info@sysmocom.de>
+ Author: Pau Espin Pedrol <pespin@sysmocom.de>
+ .
+ SPDX-License-Identifier: MIT
+ .
+ Permission is hereby granted, free of charge, to any person obtaining a copy
+ of this software and associated documentation files (the "Software"), to deal
+ in the Software without restriction, including without limitation the rights
+ to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ copies of the Software, and to permit persons to whom the Software is
+ furnished to do so, subject to the following conditions:
+ .
+ The above copyright notice and this permission notice (including the next
+ paragraph) shall be included in all copies or substantial portions of the
+ Software.
+ .
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+ SOFTWARE.
diff -pruN 1.9.0-3.1/debian/gbp.conf 1.11.0-1/debian/gbp.conf
--- 1.9.0-3.1/debian/gbp.conf	2022-10-15 10:41:32.000000000 +0000
+++ 1.11.0-1/debian/gbp.conf	2024-07-11 20:07:17.000000000 +0000
@@ -1,2 +1,4 @@
 [DEFAULT]
 pristine-tar = True
+upstream-branch=upstream
+debian-branch=master
diff -pruN 1.9.0-3.1/debian/help2man/gtp_echo_responder_see_also.h2m 1.11.0-1/debian/help2man/gtp_echo_responder_see_also.h2m
--- 1.9.0-3.1/debian/help2man/gtp_echo_responder_see_also.h2m	1970-01-01 00:00:00.000000000 +0000
+++ 1.11.0-1/debian/help2man/gtp_echo_responder_see_also.h2m	2024-07-11 20:07:17.000000000 +0000
@@ -0,0 +1,9 @@
+[DESCRIPTION]
+Stand alone program to respond to echo requests.
+
+[SEE ALSO]
+.UR "https://downloads.osmocom.org/docs/osmo-ggsn/1.9.1/osmoggsn-usermanual.pdf"
+.UE
+.P
+.UR "https://downloads.osmocom.org/docs/osmo-ggsn/1.9.1/osmoggsn-vty-reference.pdf"
+.UE
diff -pruN 1.9.0-3.1/debian/libgtp6t64.symbols 1.11.0-1/debian/libgtp6t64.symbols
--- 1.9.0-3.1/debian/libgtp6t64.symbols	2024-02-29 19:03:18.000000000 +0000
+++ 1.11.0-1/debian/libgtp6t64.symbols	2024-07-11 20:07:17.000000000 +0000
@@ -3,6 +3,7 @@ libgtp.so.6 libgtp6t64 #MINVER#
  checksum@Base 1.6.0
  eua2ipv4@Base 1.6.0
  gsna2in_addr@Base 1.6.0
+ gtp_T_defs@Base 1.11.0
  gtp_clear_queues@Base 1.6.0
  gtp_create_context_req@Base 1.6.0
  gtp_create_context_resp@Base 1.6.0
@@ -35,6 +36,7 @@ libgtp.so.6 libgtp6t64 #MINVER#
  gtp_pdp_getimsi@Base 1.6.0
  gtp_pdp_newpdp@Base 1.6.0
  gtp_pdp_tidget@Base 1.6.0
+ gtp_queue_timer_start@Base 1.11.0
  gtp_ran_info_relay_req@Base 1.8.0
  gtp_retrans@Base 1.6.0
  gtp_retranstimeout@Base 1.6.0
diff -pruN 1.9.0-3.1/debian/osmo-ggsn.cfg 1.11.0-1/debian/osmo-ggsn.cfg
--- 1.9.0-3.1/debian/osmo-ggsn.cfg	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/debian/osmo-ggsn.cfg	1970-01-01 00:00:00.000000000 +0000
@@ -1,73 +0,0 @@
-!
-! OpenGGSN (0.94.1-adac) configuration saved from vty
-!!
-!
-log stderr
- logging filter all 1
- logging color 1
- logging print category 0
- logging timestamp 0
- logging level ip info
- logging level tun info
- logging level ggsn info
- logging level sgsn notice
- logging level icmp6 notice
- logging level lglobal notice
- logging level llapd notice
- logging level linp notice
- logging level lmux notice
- logging level lmi notice
- logging level lmib notice
- logging level lsms notice
- logging level lctrl notice
- logging level lgtp info
- logging level lstats notice
- logging level lgsup notice
- logging level loap notice
- logging level lss7 notice
- logging level lsccp notice
- logging level lsua notice
- logging level lm3ua notice
- logging level lmgcp notice
-!
-stats interval 5
-!
-line vty
- no login
-!
-ggsn ggsn0
- gtp state-dir /tmp
- gtp bind-ip 127.0.0.2
- apn internet
-  gtpu-mode tun
-  tun-device tun4
-  type-support v4
-  ip prefix dynamic 172.16.222.0/24
-  ip dns 0 8.8.8.8
-  ip dns 1 8.8.4.4
-  ip ifconfig 172.16.222.0/24
-  no shutdown
- apn inet6
-  gtpu-mode tun
-  tun-device tun6
-  type-support v6
-  ipv6 prefix dynamic 2001:780:44:2000:0:0:0:0/56
-  ipv6 dns 0 2001:4860:4860::8888
-  ipv6 dns 1 2001:4860:4860::8844
-  ipv6 ifconfig 2001:780:44:2000:0:0:0:0/56
-  no shutdown
- apn inet46
-  gtpu-mode tun
-  tun-device tun46
-  type-support v4v6
-  ip prefix dynamic 172.16.46.0/24
-  ip dns 0 8.8.8.8
-  ip dns 1 8.8.4.4
-  ip ifconfig 172.16.46.0/24
-  ipv6 prefix dynamic 2001:780:44:2100:0:0:0:0/56
-  ipv6 dns 0 2001:4860:4860::8888
-  ipv6 dns 1 2001:4860:4860::8844
-  ipv6 ifconfig 2001:780:44:2100:0:0:0:0/56
-  no shutdown
- default-apn internet
- no shutdown ggsn
diff -pruN 1.9.0-3.1/debian/osmo-ggsn.install 1.11.0-1/debian/osmo-ggsn.install
--- 1.9.0-3.1/debian/osmo-ggsn.install	2022-10-15 10:41:32.000000000 +0000
+++ 1.11.0-1/debian/osmo-ggsn.install	2024-07-11 20:07:17.000000000 +0000
@@ -2,4 +2,4 @@
 /usr/bin/sgsnemu
 /usr/bin/gtp-echo-responder
 /usr/share/man/man8/*
-debian/osmo-ggsn.cfg etc/osmocom/
+/doc/examples/osmo-ggsn.cfg etc/osmocom/
diff -pruN 1.9.0-3.1/debian/osmo-ggsn.service 1.11.0-1/debian/osmo-ggsn.service
--- 1.9.0-3.1/debian/osmo-ggsn.service	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/debian/osmo-ggsn.service	2023-11-28 13:07:17.000000000 +0000
@@ -1,10 +1,13 @@
 [Unit]
 Description=OsmoGGSN
-After=networking.service
+After=network-online.target
+Wants=network-online.target
 
 [Service]
 Type=simple
 Restart=always
+StateDirectory=osmocom
+WorkingDirectory=%S/osmocom
 ExecStart=/usr/bin/osmo-ggsn -c /etc/osmocom/osmo-ggsn.cfg
 RestartSec=2
 RestartPreventExitStatus=1
diff -pruN 1.9.0-3.1/debian/patches/autotools-pkg-config-macro-not-cross-compilation-safe.patch 1.11.0-1/debian/patches/autotools-pkg-config-macro-not-cross-compilation-safe.patch
--- 1.9.0-3.1/debian/patches/autotools-pkg-config-macro-not-cross-compilation-safe.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.11.0-1/debian/patches/autotools-pkg-config-macro-not-cross-compilation-safe.patch	2024-07-11 20:07:17.000000000 +0000
@@ -0,0 +1,17 @@
+From: Nathan Doris <nate.doris@gmail.com>
+Date: Thursday, 13 June 2024
+Description: In configure.ac, replaced AC_PATH_PROG to AC_PATH_TOOL
+
+Index: osmo-ggsn/configure.ac
+===================================================================
+--- osmo-ggsn.orig/configure.ac
++++ osmo-ggsn/configure.ac
+@@ -27,7 +27,7 @@ AS_CASE(["$LD"],[*clang*],
+      [*linux*],[archive_cmds='$CC -shared $pic_flag $libobjs $deplibs $compiler_flags $wl-soname $wl$soname -o $lib'])])
+ 
+ dnl check for pkg-config (explained in detail in libosmocore/configure.ac)
+-AC_PATH_PROG(PKG_CONFIG_INSTALLED, pkg-config, no)
++AC_PATH_TOOL(PKG_CONFIG_INSTALLED, pkg-config, no)
+ if test "x$PKG_CONFIG_INSTALLED" = "xno"; then
+         AC_MSG_WARN([You need to install pkg-config])
+ fi
diff -pruN 1.9.0-3.1/debian/patches/big_endian_test_fix.patch 1.11.0-1/debian/patches/big_endian_test_fix.patch
--- 1.9.0-3.1/debian/patches/big_endian_test_fix.patch	2022-10-15 10:41:32.000000000 +0000
+++ 1.11.0-1/debian/patches/big_endian_test_fix.patch	2024-07-11 20:07:17.000000000 +0000
@@ -6,10 +6,8 @@ Subject: Fix for big-endian tests
  tests/lib/in46a_test.c | 8 +++++++-
  1 file changed, 7 insertions(+), 1 deletion(-)
 
-Index: osmo-ggsn/tests/lib/in46a_test.c
-===================================================================
---- osmo-ggsn.orig/tests/lib/in46a_test.c	2022-03-15 18:32:23.160144657 +0000
-+++ osmo-ggsn/tests/lib/in46a_test.c	2022-03-15 18:32:23.148143834 +0000
+--- a/tests/lib/in46a_test.c
++++ b/tests/lib/in46a_test.c
 @@ -12,13 +12,19 @@
  #include <osmocom/core/logging.h>
  #include <osmocom/core/msgb.h>
@@ -39,11 +37,9 @@ Index: osmo-ggsn/tests/lib/in46a_test.c
  }
  
  static void test_in46a_from_eua(void)
-Index: osmo-ggsn/gtp/gtp.c
-===================================================================
---- osmo-ggsn.orig/gtp/gtp.c	2022-03-15 18:32:23.160144657 +0000
-+++ osmo-ggsn/gtp/gtp.c	2022-03-15 18:32:23.148143834 +0000
-@@ -534,7 +534,7 @@
+--- a/gtp/gtp.c
++++ b/gtp/gtp.c
+@@ -296,7 +296,7 @@
   *
   * Echo: Automatically duplicates the original response
   * Create pdp context: The SGSN may send create context request even if
@@ -52,16 +48,7 @@ Index: osmo-ggsn/gtp/gtp.c
       automatically duplicate the original response. It might however have
   *   side effects in the application which is asked twice to validate
   *   the login.
-@@ -544,7 +544,7 @@
-  *
-  * The correct solution will be to make a queue containing response messages.
-  * This queue should be checked whenever a request is received. If the
-- * response is allready in the queue that response should be transmitted.
-+ * response is already in the queue that response should be transmitted.
-  * It should be possible to find messages in this queue on the basis of
-  * the sequence number and peer GSN IP address (The sequense number is unique
-  * within each path). This need to be implemented by a hash table. Furthermore
-@@ -2170,7 +2170,7 @@
+@@ -1734,7 +1734,7 @@
  
  	/* Is this a duplicate ? */
  	if (!gtp_duplicate(gsn, version, peer, seq)) {
@@ -70,7 +57,7 @@ Index: osmo-ggsn/gtp/gtp.c
  	}
  
  	/* Decode information elements */
-@@ -2656,7 +2656,7 @@
+@@ -2219,7 +2219,7 @@
  
  	/* Is this a duplicate ? */
  	if (!gtp_duplicate(gsn, version, peer, seq)) {
diff -pruN 1.9.0-3.1/debian/patches/gtp_echo_responder_manual_page.patch 1.11.0-1/debian/patches/gtp_echo_responder_manual_page.patch
--- 1.9.0-3.1/debian/patches/gtp_echo_responder_manual_page.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.11.0-1/debian/patches/gtp_echo_responder_manual_page.patch	2024-07-11 20:07:17.000000000 +0000
@@ -0,0 +1,47 @@
+From: Nathan Doris <nate.doris@gmail.com>
+Date: Wednesday, 26 June 2024
+Description: creates man page for gtp-echo-responder
+
+--- a/configure.ac
++++ b/configure.ac
+@@ -33,6 +33,9 @@
+ fi
+ PKG_PROG_PKG_CONFIG([0.20])
+ 
++dnl check for help2man
++AC_PATH_PROG(HELP2MAN, help2man, false)
++
+ AC_CONFIG_MACRO_DIR([m4])
+ AC_CONFIG_LIBOBJ_DIR([lib])
+ 
+--- a/utils/Makefile.am
++++ b/utils/Makefile.am
+@@ -1,3 +1,17 @@
+ bin_PROGRAMS = gtp-echo-responder
+ 
+ gtp_echo_responder_SOURCES = gtp_echo_responder.c
++
++GTP_FILE = gtp-echo-responder.8
++GTP_FPATH = $(DESTDIR)$(prefix)/share/man/man8
++
++# create gtp-echo-responder man page if it does not already exist and stop build if it does
++install-data-hook:
++	@if test ! -f $(GTP_FPATH)/$(GTP_FILE); then \
++		$(HELP2MAN) --output='$(GTP_FILE)' -s8 --name='gtp-echo-responder' --include='$(top_srcdir)/debian/help2man/gtp_echo_responder_see_also.h2m' ./gtp-echo-responder && \
++		mv $(GTP_FILE) $(GTP_FPATH)/$(GTP_FILE); \
++	else \
++		echo "ERROR : $(GTP_FILE) already exists which indicates gtp_echo_responder_manual_page.patch" \
++	       "can be removed"; \
++	       exit 1; \
++	fi
+--- a/utils/gtp_echo_responder.c
++++ b/utils/gtp_echo_responder.c
+@@ -103,7 +103,7 @@
+ 
+ static void print_help(void)
+ {
+-	printf("  Some useful help...\n"
++	printf("Options:\n"
+ 	       "  -h --help		This help text\n"
+ 	       "  -V --version		Print the version of gtp-echo-responder\n"
+ 	       "  -l --listen-addr	Listend address for GTPCv1 and GTPCv2\n"
diff -pruN 1.9.0-3.1/debian/patches/series 1.11.0-1/debian/patches/series
--- 1.9.0-3.1/debian/patches/series	2022-10-15 10:41:32.000000000 +0000
+++ 1.11.0-1/debian/patches/series	2024-07-11 20:07:17.000000000 +0000
@@ -2,3 +2,5 @@ systemd.patch
 spelling.patch
 big_endian_test_fix.patch
 endian-fix.pátch
+autotools-pkg-config-macro-not-cross-compilation-safe.patch
+gtp_echo_responder_manual_page.patch
diff -pruN 1.9.0-3.1/debian/patches/spelling.patch 1.11.0-1/debian/patches/spelling.patch
--- 1.9.0-3.1/debian/patches/spelling.patch	2022-10-15 10:41:32.000000000 +0000
+++ 1.11.0-1/debian/patches/spelling.patch	2024-07-11 20:07:17.000000000 +0000
@@ -1,9 +1,7 @@
 Description: fix spelling detected by lintian
 Author: Thorsten Alteholz <debian@alteholz.de>
-Index: osmo-ggsn/doc/sgsnemu.8
-===================================================================
---- osmo-ggsn.orig/doc/sgsnemu.8	2022-03-15 18:32:16.983720942 +0000
-+++ osmo-ggsn/doc/sgsnemu.8	2022-03-15 18:32:16.967719845 +0000
+--- a/doc/sgsnemu.8
++++ b/doc/sgsnemu.8
 @@ -238,7 +238,7 @@
  .I msisdn
  to use when connecting to the GGSN (default = 46702123456). MSISDN is
@@ -13,11 +11,9 @@ Index: osmo-ggsn/doc/sgsnemu.8
  leading 00 or 011. See the
  .I contexts
  option for the the use of the
-Index: osmo-ggsn/gtp/gtp.c
-===================================================================
---- osmo-ggsn.orig/gtp/gtp.c	2022-03-15 18:32:16.983720942 +0000
-+++ osmo-ggsn/gtp/gtp.c	2022-03-15 18:32:16.971720119 +0000
-@@ -1750,7 +1750,7 @@
+--- a/gtp/gtp.c
++++ b/gtp/gtp.c
+@@ -1303,7 +1303,7 @@
  	if (!gtp_pdp_getimsi(gsn, &pdp_old, pdp->imsi, pdp->nsapi)) {
  		/* Found old pdp with same tid. Now the voodoo begins! */
  		/* 09.60 / 29.060 allows create on existing context to "steal" */
@@ -26,7 +22,7 @@ Index: osmo-ggsn/gtp/gtp.c
  		/* We check that the APN, selection mode and MSISDN is the same */
  		DEBUGP(DLGTP, "gtp_create_pdp_ind: Old context found\n");
  		if ((pdp->apn_req.l == pdp_old->apn_req.l)
-@@ -2300,7 +2300,7 @@
+@@ -1864,7 +1864,7 @@
  		}
  
  		/* TEIC (conditional) */
@@ -35,10 +31,8 @@ Index: osmo-ggsn/gtp/gtp.c
  		/* TODO: From 29.060 it is not clear if TEI_C MUST be included for */
  		/* all updated contexts, or only for one of the linked contexts */
  		gtpie_gettv4(ie, GTPIE_TEI_C, 0, &pdp->teic_gn);
-Index: osmo-ggsn/gtp/pdp.h
-===================================================================
---- osmo-ggsn.orig/gtp/pdp.h	2022-03-15 18:32:16.983720942 +0000
-+++ osmo-ggsn/gtp/pdp.h	2022-03-15 18:32:16.971720119 +0000
+--- a/gtp/pdp.h
++++ b/gtp/pdp.h
 @@ -101,7 +101,7 @@
   * With GTP version 1 it is possible to establish multiple PDP
   * contexts with the same IP address. With this scheme the first
@@ -48,10 +42,8 @@ Index: osmo-ggsn/gtp/pdp.h
   * context is uniquely identified by IMSI and NSAPI. Each context is
   * allocated an tei_di, but they all share the same tei_c.
   *
-Index: osmo-ggsn/gtp/queue.h
-===================================================================
---- osmo-ggsn.orig/gtp/queue.h	2022-03-15 18:32:16.983720942 +0000
-+++ osmo-ggsn/gtp/queue.h	2022-03-15 18:32:16.971720119 +0000
+--- a/gtp/queue.h
++++ b/gtp/queue.h
 @@ -56,7 +56,7 @@
  int queue_new(struct queue_t **queue);
  /*  Deallocates queue structure */
@@ -61,10 +53,8 @@ Index: osmo-ggsn/gtp/queue.h
  int queue_newmsg(struct queue_t *queue, struct qmsg_t **qmsg,
  		 struct sockaddr_in *peer, uint16_t seq);
  /* Remove an element from the queue. */
-Index: osmo-ggsn/lib/ippool.c
-===================================================================
---- osmo-ggsn.orig/lib/ippool.c	2022-03-15 18:32:16.983720942 +0000
-+++ osmo-ggsn/lib/ippool.c	2022-03-15 18:32:16.971720119 +0000
+--- a/lib/ippool.c
++++ b/lib/ippool.c
 @@ -456,7 +456,7 @@
  	if (p2) {		/* Was allocated from dynamic address pool */
  		if (p2->inuse) {
@@ -74,10 +64,8 @@ Index: osmo-ggsn/lib/ippool.c
  			return -GTPCAUSE_SYS_FAIL;	/* Allready in use / Should not happen */
  		}
  
-Index: osmo-ggsn/gtp/pdp.c
-===================================================================
---- osmo-ggsn.orig/gtp/pdp.c	2022-03-15 18:32:16.983720942 +0000
-+++ osmo-ggsn/gtp/pdp.c	2022-03-15 18:32:16.971720119 +0000
+--- a/gtp/pdp.c
++++ b/gtp/pdp.c
 @@ -112,7 +112,7 @@
  	if (!g_gsn) {
  		g_gsn = gsn;
@@ -87,10 +75,8 @@ Index: osmo-ggsn/gtp/pdp.c
  		return -1;
  	}
  
-Index: osmo-ggsn/sgsnemu/sgsnemu.c
-===================================================================
---- osmo-ggsn.orig/sgsnemu/sgsnemu.c	2022-03-15 18:32:16.983720942 +0000
-+++ osmo-ggsn/sgsnemu/sgsnemu.c	2022-03-15 18:32:16.971720119 +0000
+--- a/sgsnemu/sgsnemu.c
++++ b/sgsnemu/sgsnemu.c
 @@ -1480,7 +1480,7 @@
  		src = &addr[1];
  	} else {
diff -pruN 1.9.0-3.1/debian/patches/systemd.patch 1.11.0-1/debian/patches/systemd.patch
--- 1.9.0-3.1/debian/patches/systemd.patch	2022-10-15 10:41:32.000000000 +0000
+++ 1.11.0-1/debian/patches/systemd.patch	2024-07-11 20:07:17.000000000 +0000
@@ -1,13 +1,11 @@
 Description: add Documentation field to service file
 Author: Thorsten Alteholz  <debian@alteholz.de>
-Index: osmo-ggsn-1.1.0/contrib/systemd/osmo-ggsn.service
-===================================================================
---- osmo-ggsn-1.1.0.orig/contrib/systemd/osmo-ggsn.service	2017-10-28 19:01:30.000000000 +0200
-+++ osmo-ggsn-1.1.0/contrib/systemd/osmo-ggsn.service	2017-12-17 13:30:42.380390686 +0100
-@@ -1,6 +1,7 @@
- [Unit]
+--- a/contrib/systemd/osmo-ggsn.service
++++ b/contrib/systemd/osmo-ggsn.service
+@@ -2,6 +2,7 @@
  Description=OsmoGGSN
- After=networking.service
+ After=network-online.target
+ Wants=network-online.target
 +Documentation=https://projects.osmocom.org/projects/openggsn
  
  [Service]
diff -pruN 1.9.0-3.1/doc/manuals/chapters/configuration.adoc 1.11.0-1/doc/manuals/chapters/configuration.adoc
--- 1.9.0-3.1/doc/manuals/chapters/configuration.adoc	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/doc/manuals/chapters/configuration.adoc	2023-11-28 13:07:17.000000000 +0000
@@ -302,7 +302,7 @@ Name=apn0 <1>
 Address=192.168.7.1/24 <2>
 IPMasquerade=yes <3>
 ----
-<1> The netowrk device name, which must match the one in the apn0.netdev unit file above
+<1> The network device name, which must match the one in the apn0.netdev unit file above
 <2> The local IP address configured on the device
 <3> Requesting systemd to configure IP masquerading for this interface.  Depending on your needs,
     You may not want this if you have proper end-to-end routing set up, and want to have transparent
diff -pruN 1.9.0-3.1/doc/manuals/chapters/running.adoc 1.11.0-1/doc/manuals/chapters/running.adoc
--- 1.9.0-3.1/doc/manuals/chapters/running.adoc	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/doc/manuals/chapters/running.adoc	2023-11-28 13:07:17.000000000 +0000
@@ -83,7 +83,12 @@ ggsn ggsn0
 
 === GTP-U kernel module
 
-WARNING: As of writing, the kernel module does not support IPv6.
+WARNING: As of writing, IPv6 support for the kernel module has not been
+         upstreamed yet (OS#1952).
+
+WARNING: As of writing, it is not possible to configure multiple APNs with
+         gtpu-mode kernel-gpt. This is a limitation in OsmoGGSN, not in the
+         kernel module (OS#6106).
 
 OsmoGGSN has support to use the Linux kernel GTP-U tunnel driver to accelerate
 the data/user plane while still implementing the control plane (GTP-C) in
diff -pruN 1.9.0-3.1/ggsn/Makefile.am 1.11.0-1/ggsn/Makefile.am
--- 1.9.0-3.1/ggsn/Makefile.am	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/ggsn/Makefile.am	2023-11-28 13:07:17.000000000 +0000
@@ -2,7 +2,7 @@ bin_PROGRAMS = osmo-ggsn
 
 AM_LDFLAGS = @EXEC_LDFLAGS@
 
-AM_CFLAGS = -O2 -D_GNU_SOURCE -fno-builtin -Wall -DSBINDIR='"$(sbindir)"' -ggdb $(LIBOSMOCORE_CFLAGS) $(LIBOSMOCTRL_CFLAGS) $(LIBOSMOVTY_CFLAGS)
+AM_CFLAGS = -D_GNU_SOURCE -fno-builtin -Wall -DSBINDIR='"$(sbindir)"' $(LIBOSMOCORE_CFLAGS) $(LIBOSMOCTRL_CFLAGS) $(LIBOSMOVTY_CFLAGS)
 
 osmo_ggsn_LDADD = @EXEC_LDADD@ -lgtp -L../gtp ../lib/libmisc.a $(LIBOSMOCORE_LIBS) $(LIBOSMOCTRL_LIBS) $(LIBOSMOVTY_LIBS)
 
diff -pruN 1.9.0-3.1/ggsn/ggsn.h 1.11.0-1/ggsn/ggsn.h
--- 1.9.0-3.1/ggsn/ggsn.h	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/ggsn/ggsn.h	2023-11-28 13:07:17.000000000 +0000
@@ -6,6 +6,7 @@
 #include <osmocom/core/linuxlist.h>
 #include <osmocom/core/select.h>
 #include <osmocom/core/timer.h>
+#include <osmocom/core/tdef.h>
 #include <osmocom/ctrl/control_if.h>
 
 #include "../lib/tun.h"
@@ -65,9 +66,9 @@ struct apn_ctx {
 		uint32_t apn_type_mask;
 		/* GTP-U via TUN device or in Linux kernel */
 		enum apn_gtpu_mode gtpu_mode;
-		/* administratively shut-down (true) or not (false) */
+		/* administratively shut down (true) or not (false) */
 		bool shutdown;
-		/* transmit G-PDU sequeence numbers (true) or not (false) */
+		/* transmit G-PDU sequence numbers (true) or not (false) */
 		bool tx_gpdu_seq;
 	} cfg;
 
@@ -127,7 +128,7 @@ struct ggsn_ctx {
 		char *state_dir;
 		/* Time between Echo requests on each SGSN */
 		unsigned int echo_interval;
-		/* administratively shut-down (true) or not (false) */
+		/* administratively shut down (true) or not (false) */
 		bool shutdown;
 	} cfg;
 
@@ -152,6 +153,7 @@ struct apn_ctx *ggsn_find_or_create_apn(
 /* ggsn_main.c */
 extern struct ctrl_handle *g_ctrlh;
 extern void *tall_ggsn_ctx;
+extern struct osmo_tdef_group ggsn_tdef_group[];
 
 /* ggsn.c */
 extern int ggsn_start(struct ggsn_ctx *ggsn);
diff -pruN 1.9.0-3.1/ggsn/ggsn_main.c 1.11.0-1/ggsn/ggsn_main.c
--- 1.9.0-3.1/ggsn/ggsn_main.c	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/ggsn/ggsn_main.c	2023-11-28 13:07:17.000000000 +0000
@@ -34,6 +34,7 @@
 #include <osmocom/core/stats.h>
 #include <osmocom/core/rate_ctr.h>
 #include <osmocom/core/timer.h>
+#include <osmocom/core/tdef.h>
 #include <osmocom/core/utils.h>
 #include <osmocom/ctrl/control_if.h>
 #include <osmocom/ctrl/control_cmd.h>
@@ -60,6 +61,11 @@ struct ul255_t apn;
 
 static char *config_file = "osmo-ggsn.cfg";
 
+struct osmo_tdef_group ggsn_tdef_group[] = {
+	{.name = "gtp", .tdefs = gtp_T_defs, .desc = "GTP (libgtp) timers" },
+	{ }
+};
+
 /* To exit gracefully. Used with GCC compilation flag -pg and gprof */
 static void signal_handler(int s)
 {
@@ -217,12 +223,11 @@ int main(int argc, char **argv)
 		exit(2);
 	}
 
-	rc = telnet_init_dynif(tall_ggsn_ctx, NULL, vty_get_bind_addr(), OSMO_VTY_PORT_GGSN);
+	rc = telnet_init_default(tall_ggsn_ctx, NULL, OSMO_VTY_PORT_GGSN);
 	if (rc < 0)
 		exit(1);
 
-	g_ctrlh = ctrl_interface_setup_dynip(NULL, ctrl_vty_get_bind_addr(),
-					     OSMO_CTRL_PORT_GGSN, NULL);
+	g_ctrlh = ctrl_interface_setup(NULL, OSMO_CTRL_PORT_GGSN, NULL);
 	if (!g_ctrlh) {
 		LOGP(DGGSN, LOGL_ERROR, "Failed to create CTRL interface.\n");
 		exit(1);
diff -pruN 1.9.0-3.1/ggsn/ggsn_vty.c 1.11.0-1/ggsn/ggsn_vty.c
--- 1.9.0-3.1/ggsn/ggsn_vty.c	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/ggsn/ggsn_vty.c	2023-11-28 13:07:17.000000000 +0000
@@ -33,6 +33,7 @@
 #include <osmocom/vty/command.h>
 #include <osmocom/vty/vty.h>
 #include <osmocom/vty/misc.h>
+#include <osmocom/vty/tdef_vty.h>
 
 #include "../gtp/gtp.h"
 #include "../gtp/pdp.h"
@@ -298,7 +299,7 @@ DEFUN(cfg_ggsn_no_default_apn, cfg_ggsn_
 
 DEFUN(cfg_ggsn_shutdown, cfg_ggsn_shutdown_cmd,
 	"shutdown ggsn",
-	"Put the GGSN in administrative shut-down\n" GGSN_STR)
+	"Put the GGSN in administrative shutdown\n" GGSN_STR)
 {
 	struct ggsn_ctx *ggsn = (struct ggsn_ctx *) vty->index;
 
@@ -315,7 +316,7 @@ DEFUN(cfg_ggsn_shutdown, cfg_ggsn_shutdo
 
 DEFUN(cfg_ggsn_no_shutdown, cfg_ggsn_no_shutdown_cmd,
 	"no shutdown ggsn",
-	NO_STR GGSN_STR "Remove the GGSN from administrative shut-down\n")
+	NO_STR GGSN_STR "Remove the GGSN from administrative shutdown\n")
 {
 	struct ggsn_ctx *ggsn = (struct ggsn_ctx *) vty->index;
 
@@ -343,7 +344,7 @@ static void show_one_sgsn(struct vty *vt
 
 DEFUN(cfg_ggsn_show_sgsn, cfg_ggsn_show_sgsn_cmd,
 	"show sgsn",
-	NO_STR GGSN_STR "Remove the GGSN from administrative shut-down\n")
+	NO_STR GGSN_STR "Remove the GGSN from administrative shutdown\n")
 {
 	struct ggsn_ctx *ggsn = (struct ggsn_ctx *) vty->index;
 	struct sgsn_peer *sgsn;
@@ -680,7 +681,7 @@ DEFUN(cfg_apn_no_gpdu_seq, cfg_apn_no_gp
 
 DEFUN(cfg_apn_shutdown, cfg_apn_shutdown_cmd,
 	"shutdown",
-	"Put the APN in administrative shut-down\n")
+	"Put the APN in administrative shutdown\n")
 {
 	struct apn_ctx *apn = (struct apn_ctx *) vty->index;
 
@@ -697,7 +698,7 @@ DEFUN(cfg_apn_shutdown, cfg_apn_shutdown
 
 DEFUN(cfg_apn_no_shutdown, cfg_apn_no_shutdown_cmd,
 	"no shutdown",
-	NO_STR "Remove the APN from administrative shut-down\n")
+	NO_STR "Remove the APN from administrative shutdown\n")
 {
 	struct apn_ctx *apn = (struct apn_ctx *) vty->index;
 
@@ -795,6 +796,7 @@ static int config_write_ggsn(struct vty
 			vty_out(vty, " gtp control-ip %s%s", in46a_ntoa(&ggsn->cfg.gtpc_addr), VTY_NEWLINE);
 		if (ggsn->cfg.gtpu_addr.v4.s_addr)
 			vty_out(vty, " gtp user-ip %s%s", in46a_ntoa(&ggsn->cfg.gtpu_addr), VTY_NEWLINE);
+		osmo_tdef_vty_groups_write(vty, " ");
 		llist_for_each_entry(apn, &ggsn->apn_list, list)
 			config_write_apn(vty, apn);
 		if (ggsn->cfg.default_apn)
@@ -812,10 +814,7 @@ static const char *print_gsnaddr(const s
 {
 	struct in46_addr in46;
 
-	in46.len = in->l;
-	OSMO_ASSERT(in->l <= sizeof(in46.v6));
-	memcpy(&in46.v6, in->v, in->l);
-
+	in46a_from_gsna(in, &in46);
 	return in46a_ntoa(&in46);
 }
 
@@ -1113,6 +1112,8 @@ int ggsn_vty_init(void)
 	install_element(GGSN_NODE, &cfg_ggsn_echo_interval_cmd);
 	install_element(GGSN_NODE, &cfg_ggsn_no_echo_interval_cmd);
 
+	osmo_tdef_vty_groups_init(GGSN_NODE, ggsn_tdef_group);
+
 	install_node(&apn_node, NULL);
 	install_element(APN_NODE, &cfg_description_cmd);
 	install_element(APN_NODE, &cfg_no_description_cmd);
diff -pruN 1.9.0-3.1/gtp/Makefile.am 1.11.0-1/gtp/Makefile.am
--- 1.9.0-3.1/gtp/Makefile.am	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/gtp/Makefile.am	2023-11-28 13:07:17.000000000 +0000
@@ -2,14 +2,14 @@
 # Please read chapter "Library interface versions" of the libtool documentation
 # before making any modifications: https://www.gnu.org/software/libtool/manual/html_node/Versioning.html
 # If major=current-age is increased, remember to update the dh_strip line in debian/rules!
-LIBVERSION=8:1:2
+LIBVERSION=9:1:3
 
 lib_LTLIBRARIES = libgtp.la
 
-include_HEADERS = gtp.h pdp.h gtpie.h
+include_HEADERS = gtp.h gsn.h pdp.h gtpie.h
 
-AM_CFLAGS = -O2 -fno-builtin -Wall -DSBINDIR='"$(sbindir)"' -ggdb $(LIBOSMOCORE_CFLAGS)
+AM_CFLAGS = -fno-builtin -Wall -DSBINDIR='"$(sbindir)"' $(LIBOSMOCORE_CFLAGS)
 
-libgtp_la_SOURCES = gtp.c gtp.h gtpie.c gtpie.h pdp.c pdp.h lookupa.c lookupa.h queue.c queue.h
+libgtp_la_SOURCES = gtp.c gtp.h gsn.c gsn.h gtpie.c gtpie.h pdp.c pdp.h lookupa.c lookupa.h queue.c queue.h
 libgtp_la_LDFLAGS = -version-info $(LIBVERSION) -no-undefined
 libgtp_la_LIBADD = $(LIBOSMOCORE_LIBS)
diff -pruN 1.9.0-3.1/gtp/gsn.c 1.11.0-1/gtp/gsn.c
--- 1.9.0-3.1/gtp/gsn.c	1970-01-01 00:00:00.000000000 +0000
+++ 1.11.0-1/gtp/gsn.c	2023-11-28 13:07:17.000000000 +0000
@@ -0,0 +1,596 @@
+/*
+ *  OsmoGGSN - Gateway GPRS Support Node
+ *  Copyright (C) 2002, 2003, 2004 Mondru AB.
+ *  Copyright (C) 2010-2011, 2016-2017 Harald Welte <laforge@gnumonks.org>
+ *  Copyright (C) 2015-2017 sysmocom - s.f.m.c. GmbH
+ *
+ *  The contents of this file may be used under the terms of the GNU
+ *  General Public License Version 2, provided that the above copyright
+ *  notice and this permission notice is included in all copies or
+ *  substantial portions of the software.
+ *
+ */
+
+/*
+ * gtp.c: Contains all GTP functionality. Should be able to handle multiple
+ * tunnels in the same program.
+ *
+ * TODO:
+ *  - Do we need to handle fragmentation?
+ */
+
+#ifdef __linux__
+#define _GNU_SOURCE 1
+#endif
+
+#include <osmocom/core/logging.h>
+#include <osmocom/core/utils.h>
+#include <osmocom/core/stats.h>
+#include <osmocom/core/rate_ctr.h>
+
+#if defined(__FreeBSD__)
+#include <sys/endian.h>
+#endif
+
+#include "../config.h"
+#ifdef HAVE_STDINT_H
+#include <stdint.h>
+#endif
+
+#include <stdio.h>
+#include <stdarg.h>
+#include <stdlib.h>
+#include <sys/time.h>
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#include <sys/stat.h>
+#include <time.h>
+#include <unistd.h>
+#include <string.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <inttypes.h>
+
+#include <arpa/inet.h>
+
+/* #include <stdint.h>  ISO C99 types */
+
+#include "pdp.h"
+#include "gtp.h"
+#include "gtpie.h"
+#include "queue.h"
+
+/* Error reporting functions */
+
+#define LOGP_WITH_ADDR(ss, level, addr, fmt, args...)                    \
+		LOGP(ss, level, "addr(%s:%d) " fmt,                      \
+		     inet_ntoa((addr).sin_addr), htons((addr).sin_port), \
+		     ##args);
+
+static const struct rate_ctr_desc gsn_ctr_description[] = {
+	[GSN_CTR_ERR_SOCKET] = { "err:socket", "Socket error" },
+	[GSN_CTR_ERR_READFROM] = { "err:readfrom", "readfrom() errors" },
+	[GSN_CTR_ERR_SENDTO] = { "err:sendto", "sendto() errors" },
+	[GSN_CTR_ERR_QUEUEFULL] = { "err:queuefull", "Failed to queue message because queue is full" },
+	[GSN_CTR_ERR_SEQ] = { "err:seq", "Sequence number out of range" },
+	[GSN_CTR_ERR_ADDRESS] = { "err:address", "GSN address conversion failed" },
+	[GSN_CTR_ERR_UNKNOWN_PDP] = { "err:unknown_pdp", "Failed looking up PDP context" },
+	[GSN_CTR_ERR_UNEXPECTED_CAUSE] = { "err:unexpected_cause", "Unexpected cause value received" },
+	[GSN_CTR_ERR_OUT_OF_PDP] = { "err:out_of_pdp", "Out of storage for PDP contexts" },
+	[GSN_CTR_PKT_EMPTY] = { "pkt:empty", "Empty packet received" },
+	[GSN_CTR_PKT_UNSUP] = { "pkt:unsupported", "Unsupported GTP version received" },
+	[GSN_CTR_PKT_TOOSHORT] = { "pkt:too_short", "Packet too short received" },
+	[GSN_CTR_PKT_UNKNOWN] = { "pkt:unknown", "Unknown packet type received" },
+	[GSN_CTR_PKT_UNEXPECT] = { "pkt:unexpected", "Unexpected packet type received" },
+	[GSN_CTR_PKT_DUPLICATE] = { "pkt:duplicate", "Duplicate or unsolicited packet received" },
+	[GSN_CTR_PKT_MISSING] = { "pkt:missing", "Missing IE in packet received" },
+	[GSN_CTR_PKT_INCORRECT] = { "pkt:incorrect", "Incorrect IE in packet received" },
+	[GSN_CTR_PKT_INVALID] = { "pkt:invalid", "Invalid format in packet received" },
+};
+
+static const struct rate_ctr_group_desc gsn_ctrg_desc = {
+	"gsn",
+	"GSN Statistics",
+	OSMO_STATS_CLASS_PEER,
+	ARRAY_SIZE(gsn_ctr_description),
+	gsn_ctr_description,
+};
+static unsigned int gsn_ctr_next_idx = 0;
+
+/* Global timer definitions for GTP operation, provided for convenience. To make these user configurable, it is convenient to add
+ * gtp_gsn_tdefs as one of your program's osmo_tdef_group entries and call osmo_tdef_vty_init(). */
+struct osmo_tdef gtp_T_defs[] = {
+	{ .T = GTP_GSN_TIMER_T3_RESPONSE, .default_val = 5, .unit = OSMO_TDEF_S,
+	  .desc = "Timer T3-RESPONSE holds the maximum wait time for a response of a request message"
+	},
+	{ .T = GTP_GSN_TIMER_N3_REQUESTS, .default_val = 3, .unit = OSMO_TDEF_CUSTOM,
+	  .desc = "Counter N3-REQUESTS holds the maximum number of attempts made by GTP to send a request message"
+	},
+	{ .T = GTP_GSN_TIMER_T3_HOLD_RESPONSE, .default_val = 5 * 3 /* (GTP_GSN_TIMER_T3_RESPONSE * GTP_GSN_TIMER_N3_REQUESTS) */, .unit = OSMO_TDEF_S,
+	  .desc = "Time a GTP respoonse message is kept cached to re-transmit it when a duplicate request is received. Value is generally equal to (T3-RESPONSE * N3-REQUESTS) set at the peer"
+	},
+	{}
+};
+
+
+/* API Functions */
+
+/* Deprecated, use gtp_pdp_newpdp() instead */
+int gtp_newpdp(struct gsn_t *gsn, struct pdp_t **pdp,
+	       uint64_t imsi, uint8_t nsapi)
+{
+	int rc;
+	rc = gtp_pdp_newpdp(gsn, pdp, imsi, nsapi, NULL);
+	return rc;
+}
+
+int gtp_freepdp(struct gsn_t *gsn, struct pdp_t *pdp)
+{
+	if (gsn->cb_delete_context)
+		gsn->cb_delete_context(pdp);
+	return pdp_freepdp(pdp);
+}
+
+/* Free pdp and all its secondary PDP contexts. Must be called on the primary PDP context. */
+int gtp_freepdp_teardown(struct gsn_t *gsn, struct pdp_t *pdp)
+{
+	int n;
+	struct pdp_t *secondary_pdp;
+	OSMO_ASSERT(!pdp->secondary);
+
+	for (n = 0; n < PDP_MAXNSAPI; n++) {
+		if (pdp->secondary_tei[n]) {
+			if (gtp_pdp_getgtp1(gsn, &secondary_pdp,
+					     pdp->secondary_tei[n])) {
+				LOGP(DLGTP, LOGL_ERROR,
+					"Unknown secondary PDP context\n");
+				continue;
+			}
+			if (pdp != secondary_pdp) {
+				gtp_freepdp(gsn, secondary_pdp);
+			}
+		}
+	}
+
+	return gtp_freepdp(gsn, pdp);
+}
+
+/* gtp_gpdu */
+
+extern int gtp_fd(struct gsn_t *gsn)
+{
+	return gsn->fd0;
+}
+
+int gtp_set_cb_unsup_ind(struct gsn_t *gsn,
+			 int (*cb) (struct sockaddr_in * peer))
+{
+	gsn->cb_unsup_ind = cb;
+	return 0;
+}
+
+int gtp_set_cb_extheader_ind(struct gsn_t *gsn,
+			     int (*cb) (struct sockaddr_in * peer))
+{
+	gsn->cb_extheader_ind = cb;
+	return 0;
+}
+
+int gtp_set_cb_ran_info_relay_ind(struct gsn_t *gsn,
+			     int (*cb) (struct sockaddr_in * peer, union gtpie_member **ie))
+{
+	gsn->cb_ran_info_relay_ind = cb;
+	return 0;
+}
+
+/* API: Initialise delete context callback */
+/* Called whenever a pdp context is deleted for any reason */
+int gtp_set_cb_delete_context(struct gsn_t *gsn, int (*cb) (struct pdp_t * pdp))
+{
+	gsn->cb_delete_context = cb;
+	return 0;
+}
+
+int gtp_set_cb_conf(struct gsn_t *gsn,
+		    int (*cb) (int type, int cause,
+			       struct pdp_t * pdp, void *cbp))
+{
+	gsn->cb_conf = cb;
+	return 0;
+}
+
+int gtp_set_cb_recovery(struct gsn_t *gsn,
+			int (*cb) (struct sockaddr_in * peer, uint8_t recovery))
+{
+	gsn->cb_recovery = cb;
+	return 0;
+}
+
+/* cb_recovery()
+ * pdp may be NULL if Recovery IE was received from a message independent
+ * of any PDP ctx (such as Echo Response), or because pdp ctx is unknown to the
+ * local setup. In case pdp is known, caller may want to keep that pdp alive to
+ * handle subsequent msg cb as this specific pdp ctx is still valid according to
+ * specs.
+ */
+int gtp_set_cb_recovery2(struct gsn_t *gsn,
+			int (*cb_recovery2) (struct sockaddr_in * peer, struct pdp_t * pdp, uint8_t recovery))
+{
+	gsn->cb_recovery2 = cb_recovery2;
+	return 0;
+}
+
+/* cb_recovery()
+ * pdp may be NULL if Recovery IE was received from a message independent
+ * of any PDP ctx (such as Echo Response), or because pdp ctx is unknown to the
+ * local setup. In case pdp is known, caller may want to keep that pdp alive to
+ * handle subsequent msg cb as this specific pdp ctx is still valid according to
+ * specs.
+ */
+int gtp_set_cb_recovery3(struct gsn_t *gsn,
+			 int (*cb_recovery3) (struct gsn_t *gsn, struct sockaddr_in *peer,
+					      struct pdp_t *pdp, uint8_t recovery))
+{
+	gsn->cb_recovery3 = cb_recovery3;
+	return 0;
+}
+
+int gtp_set_cb_data_ind(struct gsn_t *gsn,
+			       int (*cb_data_ind) (struct pdp_t * pdp,
+						   void *pack, unsigned len))
+{
+	gsn->cb_data_ind = cb_data_ind;
+	return 0;
+}
+
+static int queue_timer_retrans(struct gsn_t *gsn)
+{
+	/* Retransmit any outstanding packets */
+	/* Remove from queue if maxretrans exceeded */
+	time_t now;
+	struct qmsg_t *qmsg;
+	unsigned int t3_response, n3_requests;
+
+	now = time(NULL);
+	t3_response = osmo_tdef_get(gsn->tdef, GTP_GSN_TIMER_T3_RESPONSE, OSMO_TDEF_S, -1);
+	n3_requests = osmo_tdef_get(gsn->tdef, GTP_GSN_TIMER_N3_REQUESTS, OSMO_TDEF_CUSTOM, -1);
+
+	/* get first element in queue, as long as the timeout of that
+	 * element has expired */
+	while ((!queue_getfirst(gsn->queue_req, &qmsg)) &&
+	       (qmsg->timeout <= now)) {
+		if (qmsg->retrans > n3_requests) {	/* Too many retrans */
+			LOGP(DLGTP, LOGL_NOTICE, "Retransmit req queue timeout of seq %" PRIu16 "\n",
+			     qmsg->seq);
+			if (gsn->cb_conf)
+				gsn->cb_conf(qmsg->type, EOF, NULL, qmsg->cbp);
+			queue_freemsg(gsn->queue_req, qmsg);
+		} else {
+			LOGP(DLGTP, LOGL_INFO, "Retransmit (%d) of seq %" PRIu16 "\n",
+			     qmsg->retrans, qmsg->seq);
+			if (sendto(qmsg->fd, &qmsg->p, qmsg->l, 0,
+				   (struct sockaddr *)&qmsg->peer,
+				   sizeof(struct sockaddr_in)) < 0) {
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_SENDTO);
+				LOGP(DLGTP, LOGL_ERROR,
+					"Sendto(fd0=%d, msg=%lx, len=%d) failed: Error = %s\n",
+					gsn->fd0, (unsigned long)&qmsg->p,
+					qmsg->l, strerror(errno));
+			}
+			queue_back(gsn->queue_req, qmsg);
+			qmsg->timeout = now + t3_response;
+			qmsg->retrans++;
+		}
+	}
+
+	/* Also clean up reply timeouts */
+	while ((!queue_getfirst(gsn->queue_resp, &qmsg)) &&
+	       (qmsg->timeout < now)) {
+		LOGP(DLGTP, LOGL_DEBUG, "Retransmit resp queue seq %"
+		     PRIu16 " expired, removing from queue\n", qmsg->seq);
+		queue_freemsg(gsn->queue_resp, qmsg);
+	}
+
+	return 0;
+}
+
+static int queue_timer_retranstimeout(struct gsn_t *gsn, struct timeval *timeout)
+{
+	time_t now, later, diff;
+	struct qmsg_t *qmsg;
+	timeout->tv_usec = 0;
+
+	if (queue_getfirst(gsn->queue_req, &qmsg)) {
+		timeout->tv_sec = 10;
+	} else {
+		now = time(NULL);
+		later = qmsg->timeout;
+		timeout->tv_sec = later - now;
+		if (timeout->tv_sec < 0)
+			timeout->tv_sec = 0;	/* No negative allowed */
+		if (timeout->tv_sec > 10)
+			timeout->tv_sec = 10;	/* Max sleep for 10 sec */
+	}
+
+	if (queue_getfirst(gsn->queue_resp, &qmsg)) {
+		/* already set by queue_req, do nothing */
+	} else { /* trigger faster if earlier timeout exists in queue_resp */
+		now = time(NULL);
+		later = qmsg->timeout;
+		diff = later - now;
+		if (diff < 0)
+			diff = 0;
+		if (diff < timeout->tv_sec)
+			timeout->tv_sec = diff;
+	}
+
+	return 0;
+}
+
+void gtp_queue_timer_start(struct gsn_t *gsn)
+{
+	struct timeval next;
+
+	/* Retrieve next retransmission as timeval */
+	queue_timer_retranstimeout(gsn, &next);
+
+	/* re-schedule the timer */
+	osmo_timer_schedule(&gsn->queue_timer, next.tv_sec, next.tv_usec/1000);
+}
+
+/* timer callback for libgtp retransmission and ping */
+static void queue_timer_cb(void *data)
+{
+	struct gsn_t *gsn = data;
+
+	/* do all the retransmissions as needed */
+	queue_timer_retrans(gsn);
+
+	gtp_queue_timer_start(gsn);
+}
+
+
+/**
+ * @brief clear the request and response queue. Useful for debugging to reset "some" state.
+ * @param gsn The GGSN instance
+ */
+void gtp_clear_queues(struct gsn_t *gsn)
+{
+	struct qmsg_t *qmsg;
+
+	LOGP(DLGTP, LOGL_INFO, "Clearing req & resp retransmit queues\n");
+	while (!queue_getfirst(gsn->queue_req, &qmsg)) {
+		queue_freemsg(gsn->queue_req, qmsg);
+	}
+
+	while (!queue_getfirst(gsn->queue_resp, &qmsg)) {
+		queue_freemsg(gsn->queue_resp, qmsg);
+	}
+}
+
+/* Perform restoration and recovery error handling as described in 29.060 */
+static void log_restart(struct gsn_t *gsn)
+{
+	FILE *f;
+	int i, rc;
+	int counter = 0;
+	char *filename;
+
+	filename = talloc_asprintf(NULL, "%s/%s", gsn->statedir, RESTART_FILE);
+	OSMO_ASSERT(filename);
+
+	/* We try to open file. On failure we will later try to create file */
+	if (!(f = fopen(filename, "r"))) {
+		LOGP(DLGTP, LOGL_NOTICE,
+			"State information file (%s) not found. Creating new file.\n",
+			filename);
+	} else {
+		rc = fscanf(f, "%d", &counter);
+		if (rc != 1) {
+			LOGP(DLGTP, LOGL_ERROR,
+				"fscanf failed to read counter value\n");
+			goto close_file;
+		}
+		if (fclose(f)) {
+			LOGP(DLGTP, LOGL_ERROR,
+				"fclose failed: Error = %s\n", strerror(errno));
+		}
+	}
+
+	gsn->restart_counter = (unsigned char)counter;
+	gsn->restart_counter++;
+
+	/* Keep the umask closely wrapped around our fopen() call in case the
+	 * log outputs cause file creation. */
+	i = umask(022);
+	f = fopen(filename, "w");
+	umask(i);
+	if (!f) {
+		LOGP(DLGTP, LOGL_ERROR,
+			"fopen(path=%s, mode=%s) failed: Error = %s\n", filename,
+			"w", strerror(errno));
+		goto free_filename;
+	}
+
+	fprintf(f, "%d\n", gsn->restart_counter);
+close_file:
+	if (fclose(f))
+		LOGP(DLGTP, LOGL_ERROR,
+			"fclose failed: Error = %s\n", strerror(errno));
+free_filename:
+	talloc_free(filename);
+}
+
+int gtp_new(struct gsn_t **gsn, char *statedir, struct in_addr *listen,
+	    int mode)
+{
+	struct sockaddr_in addr;
+
+	LOGP(DLGTP, LOGL_NOTICE, "GTP: gtp_newgsn() started at %s\n", inet_ntoa(*listen));
+
+	*gsn = calloc(sizeof(struct gsn_t), 1);	/* TODO */
+
+	(*gsn)->statedir = statedir;
+	log_restart(*gsn);
+
+	/* Initialise sequence number */
+	(*gsn)->seq_next = (*gsn)->restart_counter * 1024;
+
+	/* Initialize timers: */
+	(*gsn)->tdef = gtp_T_defs;
+	/* Small hack to properly reset tdef for old clients not using the tdef_group: */
+	OSMO_ASSERT(gtp_T_defs[0].default_val != 0);
+	if (gtp_T_defs[0].val == 0)
+		osmo_tdefs_reset((*gsn)->tdef);
+
+
+	/* Initialise request retransmit queue */
+	queue_new(&(*gsn)->queue_req);
+	queue_new(&(*gsn)->queue_resp);
+
+	/* Initialise pdp table */
+	pdp_init(*gsn);
+
+	/* Initialize internal queue timer */
+	osmo_timer_setup(&(*gsn)->queue_timer, queue_timer_cb, *gsn);
+
+	/* Initialize counter group: */
+	(*gsn)->ctrg = rate_ctr_group_alloc(NULL, &gsn_ctrg_desc, gsn_ctr_next_idx++);
+
+	/* Initialise call back functions */
+	(*gsn)->cb_create_context_ind = 0;
+	(*gsn)->cb_delete_context = 0;
+	(*gsn)->cb_unsup_ind = 0;
+	(*gsn)->cb_conf = 0;
+	(*gsn)->cb_data_ind = 0;
+
+	/* Store function parameters */
+	(*gsn)->gsnc = *listen;
+	(*gsn)->gsnu = *listen;
+	(*gsn)->mode = mode;
+
+	/* Create GTP version 0 socket */
+	if (((*gsn)->fd0 = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
+		rate_ctr_inc2((*gsn)->ctrg, GSN_CTR_ERR_SOCKET);
+		LOGP(DLGTP, LOGL_ERROR,
+		     "GTPv0 socket(domain=%d, type=%d, protocol=%d) failed: Error = %s\n",
+			AF_INET, SOCK_DGRAM, 0, strerror(errno));
+		return -errno;
+	}
+
+	memset(&addr, 0, sizeof(addr));
+	addr.sin_family = AF_INET;
+	addr.sin_addr = *listen;	/* Same IP for user traffic and signalling */
+	addr.sin_port = htons(GTP0_PORT);
+#if defined(__FreeBSD__) || defined(__APPLE__)
+	addr.sin_len = sizeof(addr);
+#endif
+
+	if (bind((*gsn)->fd0, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
+		rate_ctr_inc2((*gsn)->ctrg, GSN_CTR_ERR_SOCKET);
+		LOGP_WITH_ADDR(DLGTP, LOGL_ERROR, addr,
+			       "bind(fd0=%d) failed: Error = %s\n",
+			       (*gsn)->fd0, strerror(errno));
+		return -errno;
+	}
+
+	/* Create GTP version 1 control plane socket */
+	if (((*gsn)->fd1c = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
+		rate_ctr_inc2((*gsn)->ctrg, GSN_CTR_ERR_SOCKET);
+		LOGP(DLGTP, LOGL_ERROR,
+		     "GTPv1 control plane socket(domain=%d, type=%d, protocol=%d) failed: Error = %s\n",
+			AF_INET, SOCK_DGRAM, 0, strerror(errno));
+		return -errno;
+	}
+
+	memset(&addr, 0, sizeof(addr));
+	addr.sin_family = AF_INET;
+	addr.sin_addr = *listen;	/* Same IP for user traffic and signalling */
+	addr.sin_port = htons(GTP1C_PORT);
+#if defined(__FreeBSD__) || defined(__APPLE__)
+	addr.sin_len = sizeof(addr);
+#endif
+
+	if (bind((*gsn)->fd1c, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
+		rate_ctr_inc2((*gsn)->ctrg, GSN_CTR_ERR_SOCKET);
+		LOGP_WITH_ADDR(DLGTP, LOGL_ERROR, addr,
+				"bind(fd1c=%d) failed: Error = %s\n",
+				(*gsn)->fd1c, strerror(errno));
+		return -errno;
+	}
+
+	/* Create GTP version 1 user plane socket */
+	if (((*gsn)->fd1u = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
+		rate_ctr_inc2((*gsn)->ctrg, GSN_CTR_ERR_SOCKET);
+		LOGP(DLGTP, LOGL_ERROR,
+		     "GTPv1 user plane socket(domain=%d, type=%d, protocol=%d) failed: Error = %s\n",
+			AF_INET, SOCK_DGRAM, 0, strerror(errno));
+		return -errno;
+	}
+
+	memset(&addr, 0, sizeof(addr));
+	addr.sin_family = AF_INET;
+	addr.sin_addr = *listen;	/* Same IP for user traffic and signalling */
+	addr.sin_port = htons(GTP1U_PORT);
+#if defined(__FreeBSD__) || defined(__APPLE__)
+	addr.sin_len = sizeof(addr);
+#endif
+
+	if (bind((*gsn)->fd1u, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
+		rate_ctr_inc2((*gsn)->ctrg, GSN_CTR_ERR_SOCKET);
+		LOGP_WITH_ADDR(DLGTP, LOGL_ERROR, addr,
+			"bind(fd1u=%d) failed: Error = %s\n",
+			(*gsn)->fd1u, strerror(errno));
+		return -errno;
+	}
+
+	/* Start internal queue timer */
+	gtp_queue_timer_start(*gsn);
+
+	return 0;
+}
+
+int gtp_free(struct gsn_t *gsn)
+{
+
+	/* Cleanup internal queue timer */
+	osmo_timer_del(&gsn->queue_timer);
+
+	/* Clean up retransmit queues */
+	queue_free(gsn->queue_req);
+	queue_free(gsn->queue_resp);
+
+	close(gsn->fd0);
+	close(gsn->fd1c);
+	close(gsn->fd1u);
+
+	rate_ctr_group_free(gsn->ctrg);
+
+	free(gsn);
+	return 0;
+}
+
+/* API: Register create context indication callback */
+int gtp_set_cb_create_context_ind(struct gsn_t *gsn,
+				  int (*cb_create_context_ind) (struct pdp_t *
+								pdp))
+{
+	gsn->cb_create_context_ind = cb_create_context_ind;
+	return 0;
+}
+
+int gtp_retrans(struct gsn_t *gsn)
+{
+	/* dummy API, deprecated. */
+	return 0;
+}
+
+int gtp_retranstimeout(struct gsn_t *gsn, struct timeval *timeout)
+{
+	timeout->tv_sec = 24*60*60;
+	timeout->tv_usec = 0;
+	/* dummy API, deprecated. Return a huge timer to do nothing */
+	return 0;
+}
diff -pruN 1.9.0-3.1/gtp/gsn.h 1.11.0-1/gtp/gsn.h
--- 1.9.0-3.1/gtp/gsn.h	1970-01-01 00:00:00.000000000 +0000
+++ 1.11.0-1/gtp/gsn.h	2023-11-28 13:07:17.000000000 +0000
@@ -0,0 +1,181 @@
+/*
+ *  OsmoGGSN - Gateway GPRS Support Node
+ *  Copyright (C) 2002, 2003, 2004 Mondru AB.
+ *
+ *  The contents of this file may be used under the terms of the GNU
+ *  General Public License Version 2, provided that the above copyright
+ *  notice and this permission notice is included in all copies or
+ *  substantial portions of the software.
+ *
+ */
+
+#ifndef _GSN_H
+#define _GSN_H
+
+#include <osmocom/core/utils.h>
+#include <osmocom/core/defs.h>
+#include <osmocom/core/timer.h>
+#include <osmocom/core/tdef.h>
+#include <osmocom/core/rate_ctr.h>
+
+#include "pdp.h"
+
+#define GTP_MODE_GGSN 1
+#define GTP_MODE_SGSN 2
+
+#define RESTART_FILE "gsn_restart"
+
+extern struct osmo_tdef gtp_T_defs[];
+
+/* ***********************************************************
+ * Information storage for each gsn instance
+ *
+ * Normally each instance of the application corresponds to
+ * one instance of a gsn.
+ *
+ * In order to avoid global variables in the application, and
+ * also in order to allow several instances of a gsn in the same
+ * application this struct is provided in order to store all
+ * relevant information related to the gsn.
+ *
+ * Note that this does not include information storage for '
+ * each pdp context. This is stored in another struct.
+ *************************************************************/
+
+enum gsn_rate_ctr_keys {
+	GSN_CTR_ERR_SOCKET,
+	GSN_CTR_ERR_READFROM,	/* Number of readfrom errors */
+	GSN_CTR_ERR_SENDTO,	/* Number of sendto errors */
+	GSN_CTR_ERR_QUEUEFULL,	/* Number of times queue was full */
+	GSN_CTR_ERR_SEQ,	/* Number of seq out of range */
+	GSN_CTR_ERR_ADDRESS,	/* GSN address conversion failed */
+	GSN_CTR_ERR_UNKNOWN_PDP,	/* GSN address conversion failed */
+	GSN_CTR_ERR_UNEXPECTED_CAUSE,	/* Unexpected cause value received */
+	GSN_CTR_ERR_OUT_OF_PDP,	/* Out of storage for PDP contexts */
+	GSN_CTR_PKT_EMPTY,		/* Number of empty packets */
+	GSN_CTR_PKT_UNSUP,		/* Number of unsupported version 29.60 11.1.1 */
+	GSN_CTR_PKT_TOOSHORT,	/* Number of too short headers 29.60 11.1.2 */
+	GSN_CTR_PKT_UNKNOWN,	/* Number of unknown messages 29.60 11.1.3 */
+	GSN_CTR_PKT_UNEXPECT,	/* Number of unexpected messages 29.60 11.1.4 */
+	GSN_CTR_PKT_DUPLICATE,	/* Number of duplicate or unsolicited replies */
+	GSN_CTR_PKT_MISSING,	/* Number of missing information field messages */
+	GSN_CTR_PKT_INCORRECT,	/* Number of incorrect information field messages */
+	GSN_CTR_PKT_INVALID,	/* Number of invalid message format messages */
+};
+
+/* 3GPP TS 29.006 14.1, 14,2 */
+enum gtp_gsn_timers {
+	GTP_GSN_TIMER_T3_RESPONSE = 3,
+	GTP_GSN_TIMER_N3_REQUESTS = 1003,
+	GTP_GSN_TIMER_T3_HOLD_RESPONSE = -3,
+};
+
+struct gsn_t {
+	/* Parameters related to the network interface */
+
+	int fd0;		/* GTP0 file descriptor */
+	int fd1c;		/* GTP1 control plane file descriptor */
+	int fd1u;		/* GTP0 user plane file descriptor */
+	int mode;		/* Mode of operation: GGSN or SGSN */
+	struct in_addr gsnc;	/* IP address of this gsn for signalling */
+	struct in_addr gsnu;	/* IP address of this gsn for user traffic */
+
+	/* Parameters related to signalling messages */
+	uint16_t seq_next;	/* Next sequence number to use */
+	int seq_first;		/* First packet in queue (oldest timeout) */
+	int seq_last;		/* Last packet in queue (youngest timeout) */
+
+	unsigned char restart_counter;	/* Increment on restart. Stored on disk */
+	char *statedir;		/* Disk location for permanent storage */
+	void *priv;		/* used by libgtp users to attach their own state) */
+	struct queue_t *queue_req;	/* Request queue */
+	struct queue_t *queue_resp;	/* Response queue */
+
+	struct pdp_t pdpa[PDP_MAX];	/* PDP storage */
+	struct pdp_t *hashtid[PDP_MAX];	/* Hash table for IMSI + NSAPI */
+
+	struct osmo_timer_list queue_timer; /* internal queue_{req,resp} timer */
+
+	/* Call back functions */
+	int (*cb_delete_context) (struct pdp_t *);
+	int (*cb_create_context_ind) (struct pdp_t *);
+	int (*cb_unsup_ind) (struct sockaddr_in * peer);
+	int (*cb_extheader_ind) (struct sockaddr_in * peer);
+	int (*cb_ran_info_relay_ind) (struct sockaddr_in *peer, union gtpie_member **ie);
+	int (*cb_conf) (int type, int cause, struct pdp_t * pdp, void *cbp);
+	int (*cb_data_ind) (struct pdp_t * pdp, void *pack, unsigned len);
+	int (*cb_recovery) (struct sockaddr_in * peer, uint8_t recovery);
+	int (*cb_recovery2) (struct sockaddr_in * peer, struct pdp_t * pdp, uint8_t recovery);
+	int (*cb_recovery3) (struct gsn_t *gsn, struct sockaddr_in *peer, struct pdp_t *pdp, uint8_t recovery);
+
+	/* Counters */
+	struct rate_ctr_group *ctrg;
+
+	/* Timers: */
+	struct osmo_tdef *tdef;
+};
+
+/* External API functions */
+
+extern int gtp_new(struct gsn_t **gsn, char *statedir, struct in_addr *listen,
+		   int mode);
+
+extern int gtp_free(struct gsn_t *gsn);
+
+extern int gtp_newpdp(struct gsn_t *gsn, struct pdp_t **pdp,
+		      uint64_t imsi, uint8_t nsapi) OSMO_DEPRECATED("Use gtp_pdp_newpdp() instead");
+extern int gtp_freepdp(struct gsn_t *gsn, struct pdp_t *pdp);
+extern int gtp_freepdp_teardown(struct gsn_t *gsn, struct pdp_t *pdp);
+
+extern int gtp_create_context_req(struct gsn_t *gsn, struct pdp_t *pdp,
+				  void *cbp);
+
+extern int gtp_set_cb_create_context_ind(struct gsn_t *gsn,
+					 int (*cb_create_context_ind) (struct
+								       pdp_t *
+								       pdp));
+extern int gtp_set_cb_data_ind(struct gsn_t *gsn,
+			       int (*cb_data_ind) (struct pdp_t * pdp,
+						   void *pack, unsigned len));
+extern int gtp_set_cb_delete_context(struct gsn_t *gsn,
+				     int (*cb_delete_context) (struct pdp_t *
+							       pdp));
+/*extern int gtp_set_cb_create_context(struct gsn_t *gsn,
+  int (*cb_create_context) (struct pdp_t* pdp)); */
+
+extern int gtp_set_cb_unsup_ind(struct gsn_t *gsn,
+				int (*cb) (struct sockaddr_in * peer));
+
+extern int gtp_set_cb_extheader_ind(struct gsn_t *gsn,
+				    int (*cb) (struct sockaddr_in * peer));
+
+extern int gtp_set_cb_ran_info_relay_ind(struct gsn_t *gsn,
+				    int (*cb) (struct sockaddr_in * peer, union gtpie_member **ie));
+
+extern int gtp_set_cb_conf(struct gsn_t *gsn,
+			   int (*cb) (int type, int cause, struct pdp_t * pdp,
+				      void *cbp));
+
+int gtp_set_cb_recovery(struct gsn_t *gsn,
+			int (*cb) (struct sockaddr_in * peer,
+				   uint8_t recovery))
+	OSMO_DEPRECATED("Use gtp_set_cb_recovery2() instead, to obtain pdp ctx originating the recovery");
+int gtp_set_cb_recovery2(struct gsn_t *gsn,
+			int (*cb) (struct sockaddr_in * peer,
+				   struct pdp_t * pdp,
+				   uint8_t recovery))
+	OSMO_DEPRECATED("Use gtp_set_cb_recovery3() instead, to obtain gsn handling the recovery");
+int gtp_set_cb_recovery3(struct gsn_t *gsn,
+			int (*cb) (struct gsn_t * gsn, struct sockaddr_in * peer,
+				   struct pdp_t * pdp,
+				   uint8_t recovery));
+void gtp_clear_queues(struct gsn_t *gsn);
+extern int gtp_fd(struct gsn_t *gsn);
+
+extern int gtp_retrans(struct gsn_t *gsn) OSMO_DEPRECATED("This API is a no-op, libgtp already does the job internally");
+extern int gtp_retranstimeout(struct gsn_t *gsn, struct timeval *timeout) OSMO_DEPRECATED("This API is a no-op and will return a 1 day timeout");
+
+/* Internal APIs: */
+void gtp_queue_timer_start(struct gsn_t *gsn);
+
+#endif /* !_GSN_H */
diff -pruN 1.9.0-3.1/gtp/gtp.c 1.11.0-1/gtp/gtp.c
--- 1.9.0-3.1/gtp/gtp.c	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/gtp/gtp.c	2023-11-28 13:07:17.000000000 +0000
@@ -60,11 +60,6 @@
 #include "gtpie.h"
 #include "queue.h"
 
-/* According to section 14.2 of 3GPP TS 29.006 version 6.9.0 */
-#define N3_REQUESTS	5
-
-#define T3_REQUEST	3
-
 /* Error reporting functions */
 
 #define GTP_LOGPKG(pri, peer, pack, len, fmt, args...)			\
@@ -131,93 +126,7 @@ const struct value_string gtp_type_names
 	{ 0, NULL }
 };
 
-/* Deprecated, use gtp_pdp_newpdp() instead */
-int gtp_newpdp(struct gsn_t *gsn, struct pdp_t **pdp,
-	       uint64_t imsi, uint8_t nsapi)
-{
-	int rc;
-	rc = gtp_pdp_newpdp(gsn, pdp, imsi, nsapi, NULL);
-	return rc;
-}
-
-int gtp_freepdp(struct gsn_t *gsn, struct pdp_t *pdp)
-{
-	if (gsn->cb_delete_context)
-		gsn->cb_delete_context(pdp);
-	return pdp_freepdp(pdp);
-}
-
-/* Free pdp and all its secondary PDP contexts. Must be called on the primary PDP context. */
-int gtp_freepdp_teardown(struct gsn_t *gsn, struct pdp_t *pdp)
-{
-	int n;
-	struct pdp_t *secondary_pdp;
-	OSMO_ASSERT(!pdp->secondary);
-
-	for (n = 0; n < PDP_MAXNSAPI; n++) {
-		if (pdp->secondary_tei[n]) {
-			if (gtp_pdp_getgtp1(gsn, &secondary_pdp,
-					     pdp->secondary_tei[n])) {
-				LOGP(DLGTP, LOGL_ERROR,
-					"Unknown secondary PDP context\n");
-				continue;
-			}
-			if (pdp != secondary_pdp) {
-				gtp_freepdp(gsn, secondary_pdp);
-			}
-		}
-	}
-
-	return gtp_freepdp(gsn, pdp);
-}
-
-/* gtp_gpdu */
-
-extern int gtp_fd(struct gsn_t *gsn)
-{
-	return gsn->fd0;
-}
-
-/* gtp_decaps */
-/* gtp_retrans */
-/* gtp_retranstimeout */
-
-int gtp_set_cb_unsup_ind(struct gsn_t *gsn,
-			 int (*cb) (struct sockaddr_in * peer))
-{
-	gsn->cb_unsup_ind = cb;
-	return 0;
-}
-
-int gtp_set_cb_extheader_ind(struct gsn_t *gsn,
-			     int (*cb) (struct sockaddr_in * peer))
-{
-	gsn->cb_extheader_ind = cb;
-	return 0;
-}
-
-int gtp_set_cb_ran_info_relay_ind(struct gsn_t *gsn,
-			     int (*cb) (struct sockaddr_in * peer, union gtpie_member **ie))
-{
-	gsn->cb_ran_info_relay_ind = cb;
-	return 0;
-}
 
-/* API: Initialise delete context callback */
-/* Called whenever a pdp context is deleted for any reason */
-int gtp_set_cb_delete_context(struct gsn_t *gsn, int (*cb) (struct pdp_t * pdp))
-{
-	gsn->cb_delete_context = cb;
-	return 0;
-}
-
-int gtp_set_cb_conf(struct gsn_t *gsn,
-		    int (*cb) (int type, int cause,
-			       struct pdp_t * pdp, void *cbp))
-{
-	gsn->cb_conf = cb;
-	return 0;
-}
 
 static void emit_cb_recovery(struct gsn_t *gsn, struct sockaddr_in * peer,
 			     struct pdp_t * pdp, uint8_t recovery)
@@ -230,50 +139,6 @@ static void emit_cb_recovery(struct gsn_
 		gsn->cb_recovery3(gsn, peer, pdp, recovery);
 }
 
-int gtp_set_cb_recovery(struct gsn_t *gsn,
-			int (*cb) (struct sockaddr_in * peer, uint8_t recovery))
-{
-	gsn->cb_recovery = cb;
-	return 0;
-}
-
-/* cb_recovery()
- * pdp may be NULL if Recovery IE was received from a message independent
- * of any PDP ctx (such as Echo Response), or because pdp ctx is unknown to the
- * local setup. In case pdp is known, caller may want to keep that pdp alive to
- * handle subsequent msg cb as this specific pdp ctx is still valid according to
- * specs.
- */
-int gtp_set_cb_recovery2(struct gsn_t *gsn,
-			int (*cb_recovery2) (struct sockaddr_in * peer, struct pdp_t * pdp, uint8_t recovery))
-{
-	gsn->cb_recovery2 = cb_recovery2;
-	return 0;
-}
-
-/* cb_recovery()
- * pdp may be NULL if Recovery IE was received from a message independent
- * of any PDP ctx (such as Echo Response), or because pdp ctx is unknown to the
- * local setup. In case pdp is known, caller may want to keep that pdp alive to
- * handle subsequent msg cb as this specific pdp ctx is still valid according to
- * specs.
- */
-int gtp_set_cb_recovery3(struct gsn_t *gsn,
-			 int (*cb_recovery3) (struct gsn_t *gsn, struct sockaddr_in *peer,
-					      struct pdp_t *pdp, uint8_t recovery))
-{
-	gsn->cb_recovery3 = cb_recovery3;
-	return 0;
-}
-
-int gtp_set_cb_data_ind(struct gsn_t *gsn,
-			       int (*cb_data_ind) (struct pdp_t * pdp,
-						   void *pack, unsigned len))
-{
-	gsn->cb_data_ind = cb_data_ind;
-	return 0;
-}
-
 /**
  * get_default_gtp()
  * Generate a GPRS Tunneling Protocol signalling packet header, depending
@@ -393,108 +258,6 @@ static uint32_t get_tei(void *pack)
 	}
 }
 
-static int queue_timer_retrans(struct gsn_t *gsn)
-{
-	/* Retransmit any outstanding packets */
-	/* Remove from queue if maxretrans exceeded */
-	time_t now;
-	struct qmsg_t *qmsg;
-	now = time(NULL);
-
-	/* get first element in queue, as long as the timeout of that
-	 * element has expired */
-	while ((!queue_getfirst(gsn->queue_req, &qmsg)) &&
-	       (qmsg->timeout <= now)) {
-		if (qmsg->retrans > N3_REQUESTS) {	/* Too many retrans */
-			LOGP(DLGTP, LOGL_NOTICE, "Retransmit req queue timeout of seq %" PRIu16 "\n",
-			     qmsg->seq);
-			if (gsn->cb_conf)
-				gsn->cb_conf(qmsg->type, EOF, NULL, qmsg->cbp);
-			queue_freemsg(gsn->queue_req, qmsg);
-		} else {
-			LOGP(DLGTP, LOGL_INFO, "Retransmit (%d) of seq %" PRIu16 "\n",
-			     qmsg->retrans, qmsg->seq);
-			if (sendto(qmsg->fd, &qmsg->p, qmsg->l, 0,
-				   (struct sockaddr *)&qmsg->peer,
-				   sizeof(struct sockaddr_in)) < 0) {
-				gsn->err_sendto++;
-				LOGP(DLGTP, LOGL_ERROR,
-					"Sendto(fd0=%d, msg=%lx, len=%d) failed: Error = %s\n",
-					gsn->fd0, (unsigned long)&qmsg->p,
-					qmsg->l, strerror(errno));
-			}
-			queue_back(gsn->queue_req, qmsg);
-			qmsg->timeout = now + T3_REQUEST;
-			qmsg->retrans++;
-		}
-	}
-
-	/* Also clean up reply timeouts */
-	while ((!queue_getfirst(gsn->queue_resp, &qmsg)) &&
-	       (qmsg->timeout < now)) {
-		LOGP(DLGTP, LOGL_DEBUG, "Retransmit resp queue seq %"
-		     PRIu16 " expired, removing from queue\n", qmsg->seq);
-		queue_freemsg(gsn->queue_resp, qmsg);
-	}
-
-	return 0;
-}
-
-static int queue_timer_retranstimeout(struct gsn_t *gsn, struct timeval *timeout)
-{
-	time_t now, later, diff;
-	struct qmsg_t *qmsg;
-	timeout->tv_usec = 0;
-
-	if (queue_getfirst(gsn->queue_req, &qmsg)) {
-		timeout->tv_sec = 10;
-	} else {
-		now = time(NULL);
-		later = qmsg->timeout;
-		timeout->tv_sec = later - now;
-		if (timeout->tv_sec < 0)
-			timeout->tv_sec = 0;	/* No negative allowed */
-		if (timeout->tv_sec > 10)
-			timeout->tv_sec = 10;	/* Max sleep for 10 sec */
-	}
-
-	if (queue_getfirst(gsn->queue_resp, &qmsg)) {
-		/* already set by queue_req, do nothing */
-	} else { /* trigger faster if earlier timeout exists in queue_resp */
-		now = time(NULL);
-		later = qmsg->timeout;
-		diff = later - now;
-		if (diff < 0)
-			diff = 0;
-		if (diff < timeout->tv_sec)
-			timeout->tv_sec = diff;
-	}
-
-	return 0;
-}
-
-static void queue_timer_start(struct gsn_t *gsn)
-{
-	struct timeval next;
-
-	/* Retrieve next retransmission as timeval */
-	queue_timer_retranstimeout(gsn, &next);
-
-	/* re-schedule the timer */
-	osmo_timer_schedule(&gsn->queue_timer, next.tv_sec, next.tv_usec/1000);
-}
-
-/* timer callback for libgtp retransmission and ping */
-static void queue_timer_cb(void *data)
-{
-	struct gsn_t *gsn = data;
-
-	/* do all the retransmissions as needed */
-	queue_timer_retrans(gsn);
-
-	queue_timer_start(gsn);
-}
-
 /* ***********************************************************
  * Reliable delivery of signalling messages
  *
@@ -543,7 +306,7 @@ static void queue_timer_cb(void *data)
  *
  * The correct solution will be to make a queue containing response messages.
  * This queue should be checked whenever a request is received. If the
- * response is allready in the queue that response should be transmitted.
+ * response is already in the queue that response should be transmitted.
  * It should be possible to find messages in this queue on the basis of
  * the sequence number and peer GSN IP address (The sequense number is unique
  * within each path). This need to be implemented by a hash table. Furthermore
@@ -620,7 +383,7 @@ static int gtp_req(struct gsn_t *gsn, ui
 
 	if (sendto(fd, packet, len, 0,
 		   (struct sockaddr *)&addr, sizeof(addr)) < 0) {
-		gsn->err_sendto++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_SENDTO);
 		LOGP(DLGTP, LOGL_ERROR, "Sendto(fd=%d, msg=%lx, len=%d, dst=%s) failed: Error = %s\n", fd,
 		     (unsigned long)&packet, len, inet_ntoa(addr.sin_addr), strerror(errno));
 		return -1;
@@ -628,15 +391,17 @@ static int gtp_req(struct gsn_t *gsn, ui
 
 	/* Use new queue structure */
 	if (queue_newmsg(gsn->queue_req, &qmsg, &addr, gsn->seq_next)) {
-		gsn->err_queuefull++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_QUEUEFULL);
 		LOGP(DLGTP, LOGL_ERROR, "Retransmit req queue is full (seq=%" PRIu16 ")\n",
 		     gsn->seq_next);
 	} else {
+		unsigned int t3_response;
 		LOGP(DLGTP, LOGL_DEBUG, "Registering seq=%" PRIu16
 		     " in restransmit req queue\n", gsn->seq_next);
+		t3_response = osmo_tdef_get(gsn->tdef, GTP_GSN_TIMER_T3_RESPONSE, OSMO_TDEF_S, -1);
 		memcpy(&qmsg->p, packet, sizeof(union gtp_packet));
 		qmsg->l = len;
-		qmsg->timeout = time(NULL) + T3_REQUEST; /* When to timeout */
+		qmsg->timeout = time(NULL) + t3_response; /* When to timeout */
 		qmsg->retrans = 0;	/* No retransmissions so far */
 		qmsg->cbp = cbp;
 		qmsg->type = ntoh8(packet->gtp0.h.type);
@@ -646,31 +411,12 @@ static int gtp_req(struct gsn_t *gsn, ui
 
 		/* Rearm timer: Retrans time for qmsg just queued may be required
 		   before an existing one (for instance a gtp echo req) */
-		queue_timer_start(gsn);
+		gtp_queue_timer_start(gsn);
 	}
 	gsn->seq_next++;	/* Count up this time */
 	return 0;
 }
 
-
-/**
- * @brief clear the request and response queue. Useful for debugging to reset "some" state.
- * @param gsn The GGSN instance
- */
-void gtp_clear_queues(struct gsn_t *gsn)
-{
-	struct qmsg_t *qmsg;
-
-	LOGP(DLGTP, LOGL_INFO, "Clearing req & resp retransmit queues\n");
-	while (!queue_getfirst(gsn->queue_req, &qmsg)) {
-		queue_freemsg(gsn->queue_req, qmsg);
-	}
-
-	while (!queue_getfirst(gsn->queue_resp, &qmsg)) {
-		queue_freemsg(gsn->queue_resp, qmsg);
-	}
-}
-
 /* gtp_conf
  * Remove signalling packet from retransmission queue.
  * return 0 on success, EOF if packet was not found */
@@ -695,7 +441,7 @@ static int gtp_conf(struct gsn_t *gsn, u
 		    "Freeing seq=%" PRIu16 " from retransmit req queue\n",
 		    seq);
 	if (queue_freemsg_seq(gsn->queue_req, peer, seq, type, cbp)) {
-		gsn->err_seq++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_SEQ);
 		GTP_LOGPKG(LOGL_ERROR, peer, packet, len,
 			    "Confirmation packet not found in retransmit req queue (seq=%"
 			    PRIu16 ")\n", seq);
@@ -705,20 +451,6 @@ static int gtp_conf(struct gsn_t *gsn, u
 	return 0;
 }
 
-int gtp_retrans(struct gsn_t *gsn)
-{
-	/* dummy API, deprecated. */
-	return 0;
-}
-
-int gtp_retranstimeout(struct gsn_t *gsn, struct timeval *timeout)
-{
-	timeout->tv_sec = 24*60*60;
-	timeout->tv_usec = 0;
-	/* dummy API, deprecated. Return a huge timer to do nothing */
-	return 0;
-}
-
 static int gtp_resp(uint8_t version, struct gsn_t *gsn, struct pdp_t *pdp,
 	     union gtp_packet *packet, int len,
 	     struct sockaddr_in *peer, int fd, uint16_t seq, uint64_t tid)
@@ -754,7 +486,7 @@ static int gtp_resp(uint8_t version, str
 
 	if (sendto(fd, packet, len, 0,
 		   (struct sockaddr *)peer, sizeof(struct sockaddr_in)) < 0) {
-		gsn->err_sendto++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_SENDTO);
 		LOGP(DLGTP, LOGL_ERROR,
 			"Sendto(fd=%d, msg=%lx, len=%d) failed: Error = %s\n", fd,
 			(unsigned long)&packet, len, strerror(errno));
@@ -763,15 +495,17 @@ static int gtp_resp(uint8_t version, str
 
 	/* Use new queue structure */
 	if (queue_newmsg(gsn->queue_resp, &qmsg, peer, seq)) {
-		gsn->err_queuefull++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_QUEUEFULL);
 		LOGP(DLGTP, LOGL_ERROR, "Retransmit resp queue is full (seq=%" PRIu16 ")\n",
 		     seq);
 	} else {
+		unsigned int t3_hold_resp;
 		LOGP(DLGTP, LOGL_DEBUG, "Registering seq=%" PRIu16
 		     " in restransmit resp queue\n", seq);
+		t3_hold_resp = osmo_tdef_get(gsn->tdef, GTP_GSN_TIMER_T3_HOLD_RESPONSE, OSMO_TDEF_S, -1);
 		memcpy(&qmsg->p, packet, sizeof(union gtp_packet));
 		qmsg->l = len;
-		qmsg->timeout = time(NULL) + 60;	/* When to timeout */
+		qmsg->timeout = time(NULL) + t3_hold_resp; /* When to timeout */
 		qmsg->retrans = 0;	/* No retransmissions so far */
 		qmsg->cbp = NULL;
 		qmsg->type = 0;
@@ -782,7 +516,7 @@ static int gtp_resp(uint8_t version, str
 
 		/* Rearm timer: Retrans time for qmsg just queued may be required
 		   before an existing one (for instance a gtp echo req) */
-		queue_timer_start(gsn);
+		gtp_queue_timer_start(gsn);
 	}
 	return 0;
 }
@@ -823,7 +557,7 @@ static int gtp_notification(struct gsn_t
 
 	if (sendto(fd, packet, len, 0,
 		   (struct sockaddr *)&addr, sizeof(struct sockaddr_in)) < 0) {
-		gsn->err_sendto++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_SENDTO);
 		LOGP(DLGTP, LOGL_ERROR,
 			"Sendto(fd=%d, msg=%lx, len=%d) failed: Error = %s\n", fd,
 			(unsigned long)&packet, len, strerror(errno));
@@ -847,6 +581,7 @@ static int gtp_duplicate(struct gsn_t *g
 	inet_ntop(AF_INET, &peer->sin_addr, buf, sizeof(buf));
 	LOGP(DLGTP, LOGL_INFO,
 		"Rx duplicate seq=%" PRIu16 " from %s, retrans resp\n", seq, buf);
+	rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_DUPLICATE);
 
 	if (fcntl(qmsg->fd, F_SETFL, 0)) {
 		LOGP(DLGTP, LOGL_ERROR, "fnctl()\n");
@@ -855,7 +590,7 @@ static int gtp_duplicate(struct gsn_t *g
 
 	if (sendto(qmsg->fd, &qmsg->p, qmsg->l, 0,
 		   (struct sockaddr *)peer, sizeof(struct sockaddr_in)) < 0) {
-		gsn->err_sendto++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_SENDTO);
 		LOGP(DLGTP, LOGL_ERROR,
 			"Sendto(fd=%d, msg=%lx, len=%d) failed: Error = %s\n",
 			qmsg->fd, (unsigned long)&qmsg->p, qmsg->l,
@@ -864,195 +599,6 @@ static int gtp_duplicate(struct gsn_t *g
 	return 0;
 }
 
-/* Perform restoration and recovery error handling as described in 29.060 */
-static void log_restart(struct gsn_t *gsn)
-{
-	FILE *f;
-	int i, rc;
-	int counter = 0;
-	char *filename;
-
-	filename = talloc_asprintf(NULL, "%s/%s", gsn->statedir, RESTART_FILE);
-	OSMO_ASSERT(filename);
-
-	/* We try to open file. On failure we will later try to create file */
-	if (!(f = fopen(filename, "r"))) {
-		LOGP(DLGTP, LOGL_NOTICE,
-			"State information file (%s) not found. Creating new file.\n",
-			filename);
-	} else {
-		rc = fscanf(f, "%d", &counter);
-		if (rc != 1) {
-			LOGP(DLGTP, LOGL_ERROR,
-				"fscanf failed to read counter value\n");
-			goto close_file;
-		}
-		if (fclose(f)) {
-			LOGP(DLGTP, LOGL_ERROR,
-				"fclose failed: Error = %s\n", strerror(errno));
-		}
-	}
-
-	gsn->restart_counter = (unsigned char)counter;
-	gsn->restart_counter++;
-
-	/* Keep the umask closely wrapped around our fopen() call in case the
-	 * log outputs cause file creation. */
-	i = umask(022);
-	f = fopen(filename, "w");
-	umask(i);
-	if (!f) {
-		LOGP(DLGTP, LOGL_ERROR,
-			"fopen(path=%s, mode=%s) failed: Error = %s\n", filename,
-			"w", strerror(errno));
-		goto free_filename;
-	}
-
-	fprintf(f, "%d\n", gsn->restart_counter);
-close_file:
-	if (fclose(f))
-		LOGP(DLGTP, LOGL_ERROR,
-			"fclose failed: Error = %s\n", strerror(errno));
-free_filename:
-	talloc_free(filename);
-}
-
-int gtp_new(struct gsn_t **gsn, char *statedir, struct in_addr *listen,
-	    int mode)
-{
-	struct sockaddr_in addr;
-
-	LOGP(DLGTP, LOGL_NOTICE, "GTP: gtp_newgsn() started at %s\n", inet_ntoa(*listen));
-
-	*gsn = calloc(sizeof(struct gsn_t), 1);	/* TODO */
-
-	(*gsn)->statedir = statedir;
-	log_restart(*gsn);
-
-	/* Initialise sequence number */
-	(*gsn)->seq_next = (*gsn)->restart_counter * 1024;
-
-	/* Initialise request retransmit queue */
-	queue_new(&(*gsn)->queue_req);
-	queue_new(&(*gsn)->queue_resp);
-
-	/* Initialise pdp table */
-	pdp_init(*gsn);
-
-	/* Initialize internal queue timer */
-	osmo_timer_setup(&(*gsn)->queue_timer, queue_timer_cb, *gsn);
-
-	/* Initialise call back functions */
-	(*gsn)->cb_create_context_ind = 0;
-	(*gsn)->cb_delete_context = 0;
-	(*gsn)->cb_unsup_ind = 0;
-	(*gsn)->cb_conf = 0;
-	(*gsn)->cb_data_ind = 0;
-
-	/* Store function parameters */
-	(*gsn)->gsnc = *listen;
-	(*gsn)->gsnu = *listen;
-	(*gsn)->mode = mode;
-
-	/* Create GTP version 0 socket */
-	if (((*gsn)->fd0 = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
-		(*gsn)->err_socket++;
-		LOGP(DLGTP, LOGL_ERROR,
-		     "GTPv0 socket(domain=%d, type=%d, protocol=%d) failed: Error = %s\n",
-			AF_INET, SOCK_DGRAM, 0, strerror(errno));
-		return -errno;
-	}
-
-	memset(&addr, 0, sizeof(addr));
-	addr.sin_family = AF_INET;
-	addr.sin_addr = *listen;	/* Same IP for user traffic and signalling */
-	addr.sin_port = htons(GTP0_PORT);
-#if defined(__FreeBSD__) || defined(__APPLE__)
-	addr.sin_len = sizeof(addr);
-#endif
-
-	if (bind((*gsn)->fd0, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
-		(*gsn)->err_socket++;
-		LOGP_WITH_ADDR(DLGTP, LOGL_ERROR, addr,
-			       "bind(fd0=%d) failed: Error = %s\n",
-			       (*gsn)->fd0, strerror(errno));
-		return -errno;
-	}
-
-	/* Create GTP version 1 control plane socket */
-	if (((*gsn)->fd1c = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
-		(*gsn)->err_socket++;
-		LOGP(DLGTP, LOGL_ERROR,
-		     "GTPv1 control plane socket(domain=%d, type=%d, protocol=%d) failed: Error = %s\n",
-			AF_INET, SOCK_DGRAM, 0, strerror(errno));
-		return -errno;
-	}
-
-	memset(&addr, 0, sizeof(addr));
-	addr.sin_family = AF_INET;
-	addr.sin_addr = *listen;	/* Same IP for user traffic and signalling */
-	addr.sin_port = htons(GTP1C_PORT);
-#if defined(__FreeBSD__) || defined(__APPLE__)
-	addr.sin_len = sizeof(addr);
-#endif
-
-	if (bind((*gsn)->fd1c, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
-		(*gsn)->err_socket++;
-		LOGP_WITH_ADDR(DLGTP, LOGL_ERROR, addr,
-				"bind(fd1c=%d) failed: Error = %s\n",
-				(*gsn)->fd1c, strerror(errno));
-		return -errno;
-	}
-
-	/* Create GTP version 1 user plane socket */
-	if (((*gsn)->fd1u = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
-		(*gsn)->err_socket++;
-		LOGP(DLGTP, LOGL_ERROR,
-		     "GTPv1 user plane socket(domain=%d, type=%d, protocol=%d) failed: Error = %s\n",
-			AF_INET, SOCK_DGRAM, 0, strerror(errno));
-		return -errno;
-	}
-
-	memset(&addr, 0, sizeof(addr));
-	addr.sin_family = AF_INET;
-	addr.sin_addr = *listen;	/* Same IP for user traffic and signalling */
-	addr.sin_port = htons(GTP1U_PORT);
-#if defined(__FreeBSD__) || defined(__APPLE__)
-	addr.sin_len = sizeof(addr);
-#endif
-
-	if (bind((*gsn)->fd1u, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
-		(*gsn)->err_socket++;
-		LOGP_WITH_ADDR(DLGTP, LOGL_ERROR, addr,
-			"bind(fd1u=%d) failed: Error = %s\n",
-			(*gsn)->fd1u, strerror(errno));
-		return -errno;
-	}
-
-	/* Start internal queue timer */
-	queue_timer_start(*gsn);
-
-	return 0;
-}
-
-int gtp_free(struct gsn_t *gsn)
-{
-
-	/* Cleanup internal queue timer */
-	osmo_timer_del(&gsn->queue_timer);
-
-	/* Clean up retransmit queues */
-	queue_free(gsn->queue_req);
-	queue_free(gsn->queue_resp);
-
-	close(gsn->fd0);
-	close(gsn->fd1c);
-	close(gsn->fd1u);
-
-	free(gsn);
-	return 0;
-}
-
 /* ***********************************************************
  * Path management messages
  * Messages: echo and version not supported.
@@ -1132,7 +678,7 @@ int gtp_echo_conf(struct gsn_t *gsn, int
 
 	/* Extract information elements into a pointer array */
 	if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-		gsn->invalid++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Invalid message format\n");
 		if (gsn->cb_conf)
@@ -1141,7 +687,7 @@ int gtp_echo_conf(struct gsn_t *gsn, int
 	}
 
 	if (gtpie_gettv1(ie, GTPIE_RECOVERY, 0, &recovery)) {
-		gsn->missing++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Missing mandatory field\n");
 		if (gsn->cb_conf)
@@ -1239,7 +785,7 @@ static int gtp_ran_info_relay_ind(struct
 
 	/* Decode information elements */
 	if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-		gsn->invalid++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Invalid message format (AN Information Relay)\n");
 		return -EINVAL;
@@ -1449,21 +995,12 @@ int gtp_create_context_resp(struct gsn_t
 	/* Now send off a reply to the peer */
 	gtp_create_pdp_resp(gsn, pdp->version, pdp, cause);
 
-	if (cause != GTPCAUSE_ACC_REQ)
+	if (!gtp_cause_successful(cause))
 		gtp_freepdp(gsn, pdp);
 
 	return 0;
 }
 
-/* API: Register create context indication callback */
-int gtp_set_cb_create_context_ind(struct gsn_t *gsn,
-				  int (*cb_create_context_ind) (struct pdp_t *
-								pdp))
-{
-	gsn->cb_create_context_ind = cb_create_context_ind;
-	return 0;
-}
-
 /* Send Create PDP Context Response */
 int gtp_create_pdp_resp(struct gsn_t *gsn, int version, struct pdp_t *pdp,
 			uint8_t cause)
@@ -1474,7 +1011,7 @@ int gtp_create_pdp_resp(struct gsn_t *gs
 
 	gtpie_tv1(&packet, &length, GTP_MAX, GTPIE_CAUSE, cause);
 
-	if (cause == GTPCAUSE_ACC_REQ) {
+	if (gtp_cause_successful(cause)) {
 
 		if (version == 0)
 			gtpie_tv0(&packet, &length, GTP_MAX, GTPIE_QOS_PROFILE0,
@@ -1560,7 +1097,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 
 	/* Decode information elements */
 	if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-		gsn->invalid++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Invalid message format\n");
 		if (0 == version)
@@ -1580,7 +1117,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 
 			/* Find the primary PDP context */
 			if (gtp_pdp_getgtp1(gsn, &linked_pdp, get_tei(pack))) {
-				gsn->incorrect++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INCORRECT);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Incorrect optional information field\n");
@@ -1590,7 +1127,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 
 			/* Check that the primary PDP context matches linked nsapi */
 			if (linked_pdp->nsapi != linked_nsapi) {
-				gsn->incorrect++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INCORRECT);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Incorrect optional information field\n");
@@ -1615,7 +1152,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 			   included in the message. */
 			if (gtpie_gettv0
 			    (ie, GTPIE_IMSI, 0, &pdp->imsi, sizeof(pdp->imsi))) {
-				gsn->missing++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 				GTP_LOGPKG(LOGL_ERROR, peer, pack,
 					    len, "Missing IMSI not supported\n");
 				return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1625,7 +1162,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 
 		/* TEID (mandatory) */
 		if (gtpie_gettv4(ie, GTPIE_TEI_DI, 0, &pdp->teid_gn)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1634,7 +1171,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 		/* TEIC (conditional) */
 		if (!linked_pdp) {	/* Not Secondary PDP Context Activation Procedure */
 			if (gtpie_gettv4(ie, GTPIE_TEI_C, 0, &pdp->teic_gn)) {
-				gsn->missing++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Missing mandatory information field\n");
@@ -1644,7 +1181,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 		}
 		/* NSAPI (mandatory) */
 		if (gtpie_gettv1(ie, GTPIE_NSAPI, 0, &pdp->nsapi)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1653,7 +1190,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 		/* QoS (mandatory) */
 		if (gtpie_gettlv(ie, GTPIE_QOS_PROFILE, 0, &pdp->qos_req.l,
 				 &pdp->qos_req.v, sizeof(pdp->qos_req.v))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1668,21 +1205,21 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 	case 0:
 		if (gtpie_gettv0(ie, GTPIE_QOS_PROFILE0, 0,
 				 pdp->qos_req0, sizeof(pdp->qos_req0))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
 						   GTPCAUSE_MAN_IE_MISSING);
 		}
 		if (gtpie_gettv2(ie, GTPIE_FL_DI, 0, &pdp->flru)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
 						   GTPCAUSE_MAN_IE_MISSING);
 		}
 		if (gtpie_gettv2(ie, GTPIE_FL_C, 0, &pdp->flrc)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1694,7 +1231,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 	/* SGSN address for signalling (mandatory) */
 	if (gtpie_gettlv(ie, GTPIE_GSN_ADDR, 0, &pdp->gsnrc.l,
 			 &pdp->gsnrc.v, sizeof(pdp->gsnrc.v))) {
-		gsn->missing++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Missing mandatory information field\n");
 		return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1704,7 +1241,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 	/* SGSN address for user traffic (mandatory) */
 	if (gtpie_gettlv(ie, GTPIE_GSN_ADDR, 1, &pdp->gsnru.l,
 			 &pdp->gsnru.v, sizeof(pdp->gsnru.v))) {
-		gsn->missing++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Missing mandatory information field\n");
 		return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1720,7 +1257,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 		/* Selection mode (conditional) */
 		if (gtpie_gettv0(ie, GTPIE_SELECTION_MODE, 0,
 				 &pdp->selmode, sizeof(pdp->selmode))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1729,7 +1266,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 		/* End User Address (conditional) */
 		if (gtpie_gettlv(ie, GTPIE_EUA, 0, &pdp->eua.l,
 				 &pdp->eua.v, sizeof(pdp->eua.v))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1738,7 +1275,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 		/* APN */
 		if (gtpie_gettlv(ie, GTPIE_APN, 0, &pdp->apn_req.l,
 				 &pdp->apn_req.v, sizeof(pdp->apn_req.v))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1751,7 +1288,7 @@ int gtp_create_pdp_ind(struct gsn_t *gsn
 		/* MSISDN (conditional) */
 		if (gtpie_gettlv(ie, GTPIE_MSISDN, 0, &pdp->msisdn.l,
 				 &pdp->msisdn.v, sizeof(pdp->msisdn.v))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_create_pdp_resp(gsn, version, pdp,
@@ -1869,7 +1406,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 
 	/* Find the context in question */
 	if (gtp_pdp_getgtp1(gsn, &pdp, get_tei(pack))) {
-		gsn->err_unknownpdp++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Unknown PDP context: %u\n", get_tei(pack));
 		if (gsn->cb_conf)
@@ -1879,7 +1416,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 
 	/* Decode information elements */
 	if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-		gsn->invalid++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Invalid message format\n");
 		if (gsn->cb_conf)
@@ -1889,7 +1426,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 
 	/* Extract cause value (mandatory) */
 	if (gtpie_gettv1(ie, GTPIE_CAUSE, 0, &cause)) {
-		gsn->missing++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Missing mandatory information field\n");
 		if (gsn->cb_conf)
@@ -1908,13 +1445,13 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 	}
 
 	/* Check all conditional information elements */
-	if (GTPCAUSE_ACC_REQ == cause) {
+	if (gtp_cause_successful(cause)) {
 
 		if (version == 0) {
 			if (gtpie_gettv0(ie, GTPIE_QOS_PROFILE0, 0,
 					 &pdp->qos_neg0,
 					 sizeof(pdp->qos_neg0))) {
-				gsn->missing++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Missing conditional information field\n");
@@ -1925,7 +1462,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 		}
 
 		if (gtpie_gettv1(ie, GTPIE_REORDER, 0, &pdp->reorder)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len,
 				    "Missing conditional information field\n");
@@ -1936,7 +1473,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 
 		if (version == 0) {
 			if (gtpie_gettv2(ie, GTPIE_FL_DI, 0, &pdp->flru)) {
-				gsn->missing++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Missing conditional information field\n");
@@ -1946,7 +1483,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 			}
 
 			if (gtpie_gettv2(ie, GTPIE_FL_C, 0, &pdp->flrc)) {
-				gsn->missing++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Missing conditional information field\n");
@@ -1958,7 +1495,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 
 		if (version == 1) {
 			if (gtpie_gettv4(ie, GTPIE_TEI_DI, 0, &pdp->teid_gn)) {
-				gsn->missing++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Missing conditional information field\n");
@@ -1968,7 +1505,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 			}
 
 			if (gtpie_gettv4(ie, GTPIE_TEI_C, 0, &pdp->teic_gn)) {
-				gsn->missing++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Missing conditional information field\n");
@@ -1981,7 +1518,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 		}
 
 		if (gtpie_gettv4(ie, GTPIE_CHARGING_ID, 0, &pdp->cid)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len,
 				    "Missing conditional information field\n");
@@ -1991,7 +1528,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 
 		if (gtpie_gettlv(ie, GTPIE_EUA, 0, &pdp->eua.l,
 				 &pdp->eua.v, sizeof(pdp->eua.v))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len,
 				    "Missing conditional information field\n");
@@ -2002,7 +1539,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 
 		if (gtpie_gettlv(ie, GTPIE_GSN_ADDR, 0, &pdp->gsnrc.l,
 				 &pdp->gsnrc.v, sizeof(pdp->gsnrc.v))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len,
 				    "Missing conditional information field\n");
@@ -2013,7 +1550,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 
 		if (gtpie_gettlv(ie, GTPIE_GSN_ADDR, 1, &pdp->gsnru.l,
 				 &pdp->gsnru.v, sizeof(pdp->gsnru.v))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len,
 				    "Missing conditional information field\n");
@@ -2026,7 +1563,7 @@ int gtp_create_pdp_conf(struct gsn_t *gs
 			if (gtpie_gettlv
 			    (ie, GTPIE_QOS_PROFILE, 0, &pdp->qos_neg.l,
 			     &pdp->qos_neg.v, sizeof(pdp->qos_neg.v))) {
-				gsn->missing++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 				GTP_LOGPKG(LOGL_ERROR, peer,
 					    pack, len,
 					    "Missing conditional information field\n");
@@ -2130,7 +1667,7 @@ static int gtp_update_pdp_resp(struct gs
 
 	gtpie_tv1(&packet, &length, GTP_MAX, GTPIE_CAUSE, cause);
 
-	if (cause == GTPCAUSE_ACC_REQ) {
+	if (gtp_cause_successful(cause)) {
 
 		if (version == 0)
 			gtpie_tv0(&packet, &length, GTP_MAX, GTPIE_QOS_PROFILE0,
@@ -2202,7 +1739,7 @@ static int gtp_update_pdp_ind(struct gsn
 
 	/* Decode information elements */
 	if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-		gsn->invalid++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Invalid message format\n");
 		if (0 == version)
@@ -2220,7 +1757,7 @@ static int gtp_update_pdp_ind(struct gsn
 	if (version == 0) {
 		/* Find the context in question */
 		if (gtp_pdp_tidget(gsn, &pdp, get_tid(pack))) {
-			gsn->err_unknownpdp++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				   "Unknown PDP context: TID=0x%" PRIx64 "\n",
 				   get_tid(pack));
@@ -2234,7 +1771,7 @@ static int gtp_update_pdp_ind(struct gsn
 	} else if (version == 1) {
 		/* NSAPI (mandatory) */
 		if (gtpie_gettv1(ie, GTPIE_NSAPI, 0, &nsapi)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			return gtp_update_pdp_resp(gsn, version, peer, fd, pack,
@@ -2246,7 +1783,7 @@ static int gtp_update_pdp_ind(struct gsn
 		if (gtpie_gettv0(ie, GTPIE_IMSI, 0, &imsi, sizeof(imsi))) {
 			/* Find the context in question */
 			if (gtp_pdp_getgtp1(gsn, &pdp, get_tei(pack))) {
-				gsn->err_unknownpdp++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 				GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 					   "Unknown PDP context: TEI=0x%" PRIx32 "\n",
 					   get_tei(pack));
@@ -2257,7 +1794,7 @@ static int gtp_update_pdp_ind(struct gsn
 		} else {
 			/* Find the context in question */
 			if (gtp_pdp_getimsi(gsn, &pdp, imsi, nsapi)) {
-				gsn->err_unknownpdp++;
+				rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 				GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 					   "Unknown PDP context: IMSI=0x%" PRIx64
 					   " NSAPI=%" PRIu8 "\n", imsi, nsapi);
@@ -2277,7 +1814,7 @@ static int gtp_update_pdp_ind(struct gsn
 	if (version == 0) {
 		if (gtpie_gettv0(ie, GTPIE_QOS_PROFILE0, 0,
 				 pdp->qos_req0, sizeof(pdp->qos_req0))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2294,7 +1831,7 @@ static int gtp_update_pdp_ind(struct gsn
 
 	if (version == 0) {
 		if (gtpie_gettv2(ie, GTPIE_FL_DI, 0, &pdp->flru)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2304,7 +1841,7 @@ static int gtp_update_pdp_ind(struct gsn
 		}
 
 		if (gtpie_gettv2(ie, GTPIE_FL_C, 0, &pdp->flrc)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2317,7 +1854,7 @@ static int gtp_update_pdp_ind(struct gsn
 	if (version == 1) {
 		/* TEID (mandatory) */
 		if (gtpie_gettv4(ie, GTPIE_TEI_DI, 0, &pdp->teid_gn)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2334,7 +1871,7 @@ static int gtp_update_pdp_ind(struct gsn
 
 		/* NSAPI (mandatory) */
 		if (gtpie_gettv1(ie, GTPIE_NSAPI, 0, &pdp->nsapi)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2350,7 +1887,7 @@ static int gtp_update_pdp_ind(struct gsn
 	/* End User Address (conditional) TODO: GGSN Initiated
 	   if (gtpie_gettlv(ie, GTPIE_EUA, 0, &pdp->eua.l,
 	   &pdp->eua.v, sizeof(pdp->eua.v))) {
-	   gsn->missing++;
+	   rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 	   GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 	   "Missing mandatory information field");
 	   memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2362,7 +1899,7 @@ static int gtp_update_pdp_ind(struct gsn
 	/* It is weird that this is mandatory when TEIC is conditional */
 	if (gtpie_gettlv(ie, GTPIE_GSN_ADDR, 0, &pdp->gsnrc.l,
 			 &pdp->gsnrc.v, sizeof(pdp->gsnrc.v))) {
-		gsn->missing++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Missing mandatory information field\n");
 		memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2373,7 +1910,7 @@ static int gtp_update_pdp_ind(struct gsn
 	/* SGSN address for user traffic (mandatory) */
 	if (gtpie_gettlv(ie, GTPIE_GSN_ADDR, 1, &pdp->gsnru.l,
 			 &pdp->gsnru.v, sizeof(pdp->gsnru.v))) {
-		gsn->missing++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Missing mandatory information field\n");
 		memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2385,7 +1922,7 @@ static int gtp_update_pdp_ind(struct gsn
 		/* QoS (mandatory) */
 		if (gtpie_gettlv(ie, GTPIE_QOS_PROFILE, 0, &pdp->qos_req.l,
 				 &pdp->qos_req.v, sizeof(pdp->qos_req.v))) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				    len, "Missing mandatory information field\n");
 			memcpy(pdp, &pdp_backup, sizeof(pdp_backup));
@@ -2427,7 +1964,7 @@ static int gtp_update_pdp_conf(struct gs
 
 	/* Decode information elements */
 	if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-		gsn->invalid++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Invalid message format\n");
 		goto err_out;
@@ -2451,7 +1988,7 @@ static int gtp_update_pdp_conf(struct gs
 	if (cause != GTPCAUSE_NON_EXIST && cause != GTPCAUSE_CONTEXT_NOT_FOUND) {
 		/* Find the context in question */
 		if (gtp_pdp_getgtp1(gsn, &pdp, get_tei(pack))) {
-			gsn->err_unknownpdp++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				   "Unknown PDP context: TEI=0x%" PRIx32 "\n", get_tei(pack));
 			goto err_out;
@@ -2460,7 +1997,7 @@ static int gtp_update_pdp_conf(struct gs
 
 	/* Check all conditional information elements */
 	/* TODO: This does not handle GGSN-initiated update responses */
-	if (cause == GTPCAUSE_ACC_REQ) {
+	if (gtp_cause_successful(cause)) {
 		if (version == 0) {
 			if (gtpie_gettv0(ie, GTPIE_QOS_PROFILE0, 0,
 					 &pdp->qos_neg0,
@@ -2520,7 +2057,7 @@ generic_ret:
 	return rc;	/* Succes */
 
 err_missing:
-	gsn->missing++;
+	rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 	GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 		    "Missing information field\n");
 err_out:
@@ -2586,7 +2123,7 @@ int gtp_delete_context_req2(struct gsn_t
 	int count;
 
 	if (gsna2in_addr(&addr, &pdp->gsnrc)) {
-		gsn->err_address++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_ADDRESS);
 		LOGP(DLGTP, LOGL_ERROR, "GSN address (len=%u) conversion failed\n", pdp->gsnrc.l);
 		return EOF;
 	}
@@ -2635,7 +2172,7 @@ int gtp_delete_pdp_resp(struct gsn_t *gs
 	gtp_resp(version, gsn, pdp, &packet, length, peer, fd,
 		 get_seq(pack), get_tid(pack));
 
-	if (cause == GTPCAUSE_ACC_REQ) {
+	if (gtp_cause_successful(cause)) {
 		if ((teardown) || (version == 0)) {	/* Remove all contexts */
 			gtp_freepdp_teardown(gsn, linked_pdp);
 		} else {
@@ -2661,7 +2198,6 @@ int gtp_delete_pdp_resp(struct gsn_t *gs
 			}
 		}
 	}
-	/* if (cause == GTPCAUSE_ACC_REQ) */
 	return 0;
 }
 
@@ -2688,7 +2224,7 @@ int gtp_delete_pdp_ind(struct gsn_t *gsn
 
 	/* Find the linked context in question */
 	if (gtp_pdp_getgtp1(gsn, &linked_pdp, get_tei(pack))) {
-		gsn->err_unknownpdp++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			   "Unknown PDP context: TEI=0x%" PRIx32 "\n", get_tei(pack));
 		return gtp_delete_pdp_resp(gsn, version, peer, fd, pack, len,
@@ -2702,7 +2238,7 @@ int gtp_delete_pdp_ind(struct gsn_t *gsn
 
 	/* Decode information elements */
 	if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-		gsn->invalid++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Invalid message format\n");
 		if (0 == version)
@@ -2717,7 +2253,7 @@ int gtp_delete_pdp_ind(struct gsn_t *gsn
 	if (version == 1) {
 		/* NSAPI (mandatory) */
 		if (gtpie_gettv1(ie, GTPIE_NSAPI, 0, &nsapi)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack,
 				   len, "Missing mandatory information field\n");
 			return gtp_delete_pdp_resp(gsn, version, peer, fd, pack,
@@ -2728,7 +2264,7 @@ int gtp_delete_pdp_ind(struct gsn_t *gsn
 
 		/* Find the context in question */
 		if (gtp_pdp_getgtp1(gsn, &pdp, linked_pdp->secondary_tei[nsapi & 0x0f])) {
-			gsn->err_unknownpdp++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				   "Unknown PDP context: Secondary TEI=0x%" PRIx32 "\n",
 				   linked_pdp->secondary_tei[nsapi & 0x0f]);
@@ -2782,7 +2318,7 @@ int gtp_delete_pdp_conf(struct gsn_t *gs
 	/* Find the context in question. It may not be available if gtp_delete_context_req
 	 * was used and as a result the PDP ctx was already freed */
 	if (gtp_pdp_getgtp1(gsn, &pdp, get_tei(pack))) {
-		gsn->err_unknownpdp++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 		GTP_LOGPKG(LOGL_NOTICE, peer, pack, len,
 			   "Unknown PDP context: TEI=0x%" PRIx32 " (expected if "
 			   "gtp_delete_context_req is used or pdp ctx was freed "
@@ -2794,7 +2330,7 @@ int gtp_delete_pdp_conf(struct gsn_t *gs
 
 	/* Decode information elements */
 	if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-		gsn->invalid++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Invalid message format\n");
 		if (gsn->cb_conf)
@@ -2804,7 +2340,7 @@ int gtp_delete_pdp_conf(struct gsn_t *gs
 
 	/* Extract cause value (mandatory) */
 	if (gtpie_gettv1(ie, GTPIE_CAUSE, 0, &cause)) {
-		gsn->missing++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Missing mandatory information field\n");
 		if (gsn->cb_conf)
@@ -2813,8 +2349,8 @@ int gtp_delete_pdp_conf(struct gsn_t *gs
 	}
 
 	/* Check the cause value (again) */
-	if ((GTPCAUSE_ACC_REQ != cause) && (GTPCAUSE_NON_EXIST != cause)) {
-		gsn->err_cause++;
+	if (!gtp_cause_successful(cause) && (GTPCAUSE_NON_EXIST != cause)) {
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNEXPECTED_CAUSE);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 			    "Unexpected cause value received: %d\n", cause);
 		if (gsn->cb_conf)
@@ -2861,7 +2397,7 @@ static int gtp_error_ind_conf(struct gsn
 	/* Find the context in question */
 	if (version == 0) {
 		if (gtp_pdp_tidget(gsn, &pdp, get_tid(pack))) {
-			gsn->err_unknownpdp++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				   "Unknown PDP context: TID=0x%" PRIx64 "\n",
 				   get_tid(pack));
@@ -2874,21 +2410,21 @@ static int gtp_error_ind_conf(struct gsn
 
 		/* Decode information elements */
 		if (gtpie_decaps(ie, version, pack + hlen, len - hlen)) {
-			gsn->invalid++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_INVALID);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				    "Invalid message format\n");
 			return EOF;
 		}
 
 		if (gtpie_gettv4(ie, GTPIE_TEI_DI, 0, &teid_gn)) {
-			gsn->missing++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_MISSING);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				    "Missing mandatory information field\n");
 			return EOF;
 		}
 
 		if (gtp_pdp_getgtp1_peer_d(gsn, &pdp, peer, teid_gn)) {
-			gsn->err_unknownpdp++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				   "Unknown PDP context: Peer TEID=0x%" PRIx32 "\n",
 				   teid_gn);
@@ -2923,7 +2459,7 @@ static int gtp_gpdu_ind(struct gsn_t *gs
 	switch (version) {
 	case 0:
 		if (gtp_pdp_getgtp0(gsn, &pdp, get_tei(pack))) {
-			gsn->err_unknownpdp++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				   "Unknown PDP context: TEI=0x%" PRIx32 "\n",
 				   get_tei(pack));
@@ -2934,7 +2470,7 @@ static int gtp_gpdu_ind(struct gsn_t *gs
 		break;
 	case 1:
 		if (gtp_pdp_getgtp1(gsn, &pdp, get_tei(pack))) {
-			gsn->err_unknownpdp++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 			GTP_LOGPKG(LOGL_ERROR, peer, pack, len,
 				   "Unknown PDP context: TEI=0x%" PRIx32 "\n",
 				   get_tei(pack));
@@ -2956,7 +2492,7 @@ static int gtp_gpdu_ind(struct gsn_t *gs
 
 	/* If the GPDU was not from the peer GSN tell him to delete context */
 	if (memcmp(&peer->sin_addr, pdp->gsnru.v, pdp->gsnru.l)) {	/* TODO Range? */
-		gsn->err_unknownpdp++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_UNKNOWN_PDP);
 		GTP_LOGPKG(LOGL_ERROR, peer, pack, len, "Unknown GSN peer %s\n", inet_ntoa(peer->sin_addr));
 		return gtp_error_ind_resp(gsn, version, peer, fd, pack, len);
 	}
@@ -2998,7 +2534,7 @@ int gtp_decaps0(struct gsn_t *gsn)
 			      (struct sockaddr *)&peer, &peerlen)) < 0) {
 			if (errno == EAGAIN)
 				return 0;
-			gsn->err_readfrom++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_READFROM);
 			LOGP(DLGTP, LOGL_ERROR,
 				"recvfrom(fd0=%d, buffer=%lx, len=%zu) failed: status = %d error = %s\n",
 				gsn->fd0, (unsigned long)buffer, sizeof(buffer),
@@ -3008,7 +2544,7 @@ int gtp_decaps0(struct gsn_t *gsn)
 
 		/* Need at least 1 byte in order to check version */
 		if (status < (1)) {
-			gsn->empty++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_EMPTY);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "Discarding packet - too small\n");
 			continue;
@@ -3024,7 +2560,7 @@ int gtp_decaps0(struct gsn_t *gsn)
 		/* only support version 0, implying that this is the only version */
 		/* supported on this port */
 		if (version > 0) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer, status,
 				"Unsupported GTP version %"PRIu8"\n", version);
 			gtp_unsup_req(gsn, 0, &peer, gsn->fd0, buffer, status);	/* 29.60: 11.1.1 */
@@ -3033,7 +2569,7 @@ int gtp_decaps0(struct gsn_t *gsn)
 
 		/* Check length of gtp0 packet */
 		if (status < GTP0_HEADER_SIZE) {
-			gsn->tooshort++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_TOOSHORT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "GTP0 packet too short\n");
 			continue;	/* Silently discard 29.60: 11.1.2 */
@@ -3041,7 +2577,7 @@ int gtp_decaps0(struct gsn_t *gsn)
 
 		/* Check packet length field versus length of packet */
 		if (status != (ntoh16(pheader->length) + GTP0_HEADER_SIZE)) {
-			gsn->tooshort++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_TOOSHORT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status,
 				    "GTP packet length field does not match actual length\n");
@@ -3051,7 +2587,7 @@ int gtp_decaps0(struct gsn_t *gsn)
 		if ((gsn->mode == GTP_MODE_GGSN) &&
 		    ((pheader->type == GTP_CREATE_PDP_RSP) ||
 		     (pheader->type == GTP_UPDATE_PDP_RSP))) {
-			gsn->unexpect++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNEXPECT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status,
 				    "Unexpected GTPv0 Signalling Message '%s'\n",
@@ -3062,7 +2598,7 @@ int gtp_decaps0(struct gsn_t *gsn)
 		if ((gsn->mode == GTP_MODE_SGSN) &&
 		    ((pheader->type == GTP_CREATE_PDP_REQ) ||
 		     (pheader->type == GTP_UPDATE_PDP_REQ))) {
-			gsn->unexpect++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNEXPECT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status,
 				    "Unexpected GTPv0 Signalling Message '%s'\n",
@@ -3111,7 +2647,7 @@ int gtp_decaps0(struct gsn_t *gsn)
 			gtp_gpdu_ind(gsn, version, &peer, fd, buffer, status);
 			break;
 		default:
-			gsn->unknown++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNKNOWN);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer, status,
 				"Unknown GTP message type received: %d\n",
 				pheader->type);
@@ -3145,7 +2681,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 			      (struct sockaddr *)&peer, &peerlen)) < 0) {
 			if (errno == EAGAIN)
 				return 0;
-			gsn->err_readfrom++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_READFROM);
 			LOGP(DLGTP, LOGL_ERROR,
 				"recvfrom(fd=%d, buffer=%lx, len=%zu) failed: status = %d error = %s\n",
 				fd, (unsigned long)buffer, sizeof(buffer),
@@ -3155,7 +2691,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 
 		/* Need at least 1 byte in order to check version */
 		if (status < (1)) {
-			gsn->empty++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_EMPTY);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "Discarding packet - too small\n");
 			continue;
@@ -3167,7 +2703,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 
 		/* Version must be no larger than GTP 1 */
 		if (version > 1) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer, status,
 				"Unsupported GTP version %"PRIu8"\n", version);
 			gtp_unsup_req(gsn, version, &peer, fd, buffer, status);
@@ -3180,7 +2716,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 		/* GTP 1 messages. If GTP 0 message is received we silently discard */
 		/* the message */
 		if (version < 1) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer, status,
 				"Unsupported GTP version %"PRIu8"\n", version);
 			continue;
@@ -3188,7 +2724,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 
 		/* Check packet flag field */
 		if (((pheader->flags & 0xf7) != 0x32)) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "Unsupported packet flags: 0x%02x\n", pheader->flags);
 			continue;
@@ -3196,7 +2732,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 
 		/* Check length of packet */
 		if (status < GTP1_HEADER_SIZE_LONG) {
-			gsn->tooshort++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_TOOSHORT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "GTP packet too short\n");
 			continue;	/* Silently discard 29.60: 11.1.2 */
@@ -3205,7 +2741,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 		/* Check packet length field versus length of packet */
 		if (status !=
 		    (ntoh16(pheader->length) + GTP1_HEADER_SIZE_SHORT)) {
-			gsn->tooshort++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_TOOSHORT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status,
 				    "GTP packet length field does not match actual length\n");
@@ -3216,7 +2752,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 		/* TODO: We really should cycle through the headers and determine */
 		/* if any have the comprehension required flag set */
 		if (((pheader->flags & GTP1HDR_F_EXT) != 0x00)) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "Unsupported extension header\n");
 			gtp_extheader_req(gsn, version, &peer, fd, buffer,
@@ -3228,7 +2764,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 		if ((gsn->mode == GTP_MODE_GGSN) &&
 		    ((pheader->type == GTP_CREATE_PDP_RSP) ||
 		     (pheader->type == GTP_UPDATE_PDP_RSP))) {
-			gsn->unexpect++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNEXPECT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status,
 				    "Unexpected GTPv1 Signalling Message '%s'\n",
@@ -3239,7 +2775,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 		if ((gsn->mode == GTP_MODE_SGSN) &&
 		    ((pheader->type == GTP_CREATE_PDP_REQ) ||
 		     (pheader->type == GTP_UPDATE_PDP_REQ))) {
-			gsn->unexpect++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNEXPECT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status,
 				    "Unexpected GTPv1 Signalling Message '%s'\n",
@@ -3291,7 +2827,7 @@ int gtp_decaps1c(struct gsn_t *gsn)
 			gtp_ran_info_relay_ind(gsn, version, &peer, buffer, status);
 			break;
 		default:
-			gsn->unknown++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNKNOWN);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer, status,
 				"Unknown GTP message type received: %u\n",
 				pheader->type);
@@ -3325,7 +2861,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 			      (struct sockaddr *)&peer, &peerlen)) < 0) {
 			if (errno == EAGAIN)
 				return 0;
-			gsn->err_readfrom++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_READFROM);
 			LOGP(DLGTP, LOGL_ERROR,
 				"recvfrom(fd1u=%d, buffer=%lx, len=%zu) failed: status = %d error = %s\n",
 				gsn->fd1u, (unsigned long)buffer,
@@ -3336,7 +2872,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 
 		/* Need at least 1 byte in order to check version */
 		if (status < (1)) {
-			gsn->empty++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_EMPTY);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "Discarding packet - too small\n");
 			continue;
@@ -3348,7 +2884,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 
 		/* Version must be no larger than GTP 1 */
 		if (version > 1) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer, status,
 				"Unsupported GTP version %"PRIu8"\n", version);
 			gtp_unsup_req(gsn, 1, &peer, gsn->fd1c, buffer, status);	/*29.60: 11.1.1 */
@@ -3360,7 +2896,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 		/* GTP 1 messages. If GTP 0 message is received we silently discard */
 		/* the message */
 		if (version < 1) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer, status,
 				"Unsupported GTP version %"PRIu8"\n", version);
 			continue;
@@ -3368,7 +2904,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 
 		/* Check packet flag field (allow both with and without sequence number) */
 		if (((pheader->flags & 0xf5) != 0x30)) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "Unsupported packet flags 0x%02x\n", pheader->flags);
 			continue;
@@ -3376,7 +2912,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 
 		/* Check length of packet */
 		if (status < GTP1_HEADER_SIZE_SHORT) {
-			gsn->tooshort++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_TOOSHORT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "GTP packet too short\n");
 			continue;	/* Silently discard 29.60: 11.1.2 */
@@ -3385,7 +2921,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 		/* Check packet length field versus length of packet */
 		if (status !=
 		    (ntoh16(pheader->length) + GTP1_HEADER_SIZE_SHORT)) {
-			gsn->tooshort++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_TOOSHORT);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status,
 				    "GTP packet length field does not match actual length\n");
@@ -3396,7 +2932,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 		/* TODO: We really should cycle through the headers and determine */
 		/* if any have the comprehension required flag set */
 		if (((pheader->flags & GTP1HDR_F_EXT) != 0x00)) {
-			gsn->unsup++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNSUP);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer,
 				    status, "Unsupported extension header\n");
 			gtp_extheader_req(gsn, version, &peer, fd, buffer,
@@ -3423,7 +2959,7 @@ int gtp_decaps1u(struct gsn_t *gsn)
 			gtp_gpdu_ind(gsn, version, &peer, fd, buffer, status);
 			break;
 		default:
-			gsn->unknown++;
+			rate_ctr_inc2(gsn->ctrg, GSN_CTR_PKT_UNKNOWN);
 			GTP_LOGPKG(LOGL_ERROR, &peer, buffer, status,
 				"Unknown GTP message type received: %u\n",
 				pheader->type);
@@ -3504,7 +3040,7 @@ int gtp_data_req(struct gsn_t *gsn, stru
 	}
 
 	if (sendmsg(fd, &msgh, 0) < 0) {
-		gsn->err_sendto++;
+		rate_ctr_inc2(gsn->ctrg, GSN_CTR_ERR_SENDTO);
 		LOGP(DLGTP, LOGL_ERROR,
 			"sendmsg(fd=%d, msg=%lx, len=%d) failed: Error = %s\n", fd,
 			(unsigned long)&packet, GTP0_HEADER_SIZE + len,
diff -pruN 1.9.0-3.1/gtp/gtp.h 1.11.0-1/gtp/gtp.h
--- 1.9.0-3.1/gtp/gtp.h	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/gtp/gtp.h	2023-11-28 13:07:17.000000000 +0000
@@ -13,14 +13,10 @@
 #define _GTP_H
 
 #include <osmocom/core/utils.h>
-#include <osmocom/core/defs.h>
-#include <osmocom/core/timer.h>
 
 #include "gtpie.h"
 #include "pdp.h"
-
-#define GTP_MODE_GGSN 1
-#define GTP_MODE_SGSN 2
+#include "gsn.h"
 
 #define GTP0_PORT	3386
 #define GTP1C_PORT	2123
@@ -32,12 +28,10 @@
 #define GTP1_HEADER_SIZE_SHORT  8
 #define GTP1_HEADER_SIZE_LONG  12
 
+#define NAMESIZE 1024
 #define SYSLOG_PRINTSIZE 255
 #define ERRMSG_SIZE 255
 
-#define RESTART_FILE "gsn_restart"
-#define NAMESIZE 1024
-
 /* GTP version 1 extension header type definitions. */
 #define GTP_EXT_PDCP_PDU    0xC0	/* PDCP PDU Number */
 
@@ -109,7 +103,9 @@ static inline const char *gtp_type_name(
 #define GTPCAUSE_049                       49	/* Cause values reserved for GPRS charging protocol use (See GTP' in GSM 12.15) 49-63 */
 #define GTPCAUSE_064                       64	/* For future use 64-127 */
 #define GTPCAUSE_ACC_REQ                  128	/* Request accepted */
-#define GTPCAUSE_129                      129	/* For future use 129-176 */
+#define GTPCAUSE_NEW_PDP_NET_PREF         129	/* New PDP type due to network preference */
+#define GTPCAUSE_NEW_PDP_ADDR_BEAR        130	/* New PDP type due to single address bearer only */
+#define GTPCAUSE_131                      131	/* For future use 131-176 */
 #define GTPCAUSE_177                      177	/* Cause values reserved for GPRS charging protocol use (See GTP' In GSM 12.15) 177-191 */
 #define GTPCAUSE_NON_EXIST                192	/* Non-existent */
 #define GTPCAUSE_INVALID_MESSAGE          193	/* Invalid message format */
@@ -143,6 +139,13 @@ static inline const char *gtp_type_name(
 #define GTPCAUSE_221                      221	/* For Future Use 221-240 */
 #define GTPCAUSE_241                      241	/* Cause Values Reserved For Gprs Charging Protocol Use (See Gtp' In Gsm 12.15) 241-255 */
 
+static inline bool gtp_cause_successful(uint8_t cause)
+{
+	return cause == GTPCAUSE_ACC_REQ ||
+		cause == GTPCAUSE_NEW_PDP_NET_PREF ||
+		cause == GTPCAUSE_NEW_PDP_ADDR_BEAR;
+}
+
 struct ul66_t;
 struct ul16_t;
 struct pdp_t;
@@ -232,105 +235,13 @@ union gtp_packet {
 	struct gtp1_packet_long gtp1l;
 } __attribute__ ((packed));
 
-/* ***********************************************************
- * Information storage for each gsn instance
- *
- * Normally each instance of the application corresponds to
- * one instance of a gsn.
- *
- * In order to avoid global variables in the application, and
- * also in order to allow several instances of a gsn in the same
- * application this struct is provided in order to store all
- * relevant information related to the gsn.
- *
- * Note that this does not include information storage for '
- * each pdp context. This is stored in another struct.
- *************************************************************/
-
-struct gsn_t {
-	/* Parameters related to the network interface */
-
-	int fd0;		/* GTP0 file descriptor */
-	int fd1c;		/* GTP1 control plane file descriptor */
-	int fd1u;		/* GTP0 user plane file descriptor */
-	int mode;		/* Mode of operation: GGSN or SGSN */
-	struct in_addr gsnc;	/* IP address of this gsn for signalling */
-	struct in_addr gsnu;	/* IP address of this gsn for user traffic */
-
-	/* Parameters related to signalling messages */
-	uint16_t seq_next;	/* Next sequence number to use */
-	int seq_first;		/* First packet in queue (oldest timeout) */
-	int seq_last;		/* Last packet in queue (youngest timeout) */
-
-	unsigned char restart_counter;	/* Increment on restart. Stored on disk */
-	char *statedir;		/* Disk location for permanent storage */
-	void *priv;		/* used by libgtp users to attach their own state) */
-	struct queue_t *queue_req;	/* Request queue */
-	struct queue_t *queue_resp;	/* Response queue */
-
-	struct pdp_t pdpa[PDP_MAX];	/* PDP storage */
-	struct pdp_t *hashtid[PDP_MAX];	/* Hash table for IMSI + NSAPI */
-
-	struct osmo_timer_list queue_timer; /* internal queue_{req,resp} timer */
-
-	/* Call back functions */
-	int (*cb_delete_context) (struct pdp_t *);
-	int (*cb_create_context_ind) (struct pdp_t *);
-	int (*cb_unsup_ind) (struct sockaddr_in * peer);
-	int (*cb_extheader_ind) (struct sockaddr_in * peer);
-	int (*cb_ran_info_relay_ind) (struct sockaddr_in *peer, union gtpie_member **ie);
-	int (*cb_conf) (int type, int cause, struct pdp_t * pdp, void *cbp);
-	int (*cb_data_ind) (struct pdp_t * pdp, void *pack, unsigned len);
-	int (*cb_recovery) (struct sockaddr_in * peer, uint8_t recovery);
-	int (*cb_recovery2) (struct sockaddr_in * peer, struct pdp_t * pdp, uint8_t recovery);
-	int (*cb_recovery3) (struct gsn_t *gsn, struct sockaddr_in *peer, struct pdp_t *pdp, uint8_t recovery);
-
-	/* Counters */
-
-	uint64_t err_socket;	/* Number of socket errors */
-	uint64_t err_readfrom;	/* Number of readfrom errors */
-	uint64_t err_sendto;	/* Number of sendto errors */
-	uint64_t err_memcpy;	/* Number of memcpy */
-	uint64_t err_queuefull;	/* Number of times queue was full */
-	uint64_t err_seq;	/* Number of seq out of range */
-	uint64_t err_address;	/* GSN address conversion failed */
-	uint64_t err_unknownpdp;	/* GSN address conversion failed */
-	uint64_t err_unknowntid;	/* Application supplied unknown imsi+nsapi */
-	uint64_t err_cause;	/* Unexpected cause value received */
-	uint64_t err_outofpdp;	/* Out of storage for PDP contexts */
-
-	uint64_t empty;		/* Number of empty packets */
-	uint64_t unsup;		/* Number of unsupported version 29.60 11.1.1 */
-	uint64_t tooshort;	/* Number of too short headers 29.60 11.1.2 */
-	uint64_t unknown;	/* Number of unknown messages 29.60 11.1.3 */
-	uint64_t unexpect;	/* Number of unexpected messages 29.60 11.1.4 */
-	uint64_t duplicate;	/* Number of duplicate or unsolicited replies */
-	uint64_t missing;	/* Number of missing information field messages */
-	uint64_t incorrect;	/* Number of incorrect information field messages */
-	uint64_t invalid;	/* Number of invalid message format messages */
-};
-
 /* External API functions */
 
 extern const char *gtp_version();
-extern int gtp_new(struct gsn_t **gsn, char *statedir, struct in_addr *listen,
-		   int mode);
-
-extern int gtp_free(struct gsn_t *gsn);
-
-extern int gtp_newpdp(struct gsn_t *gsn, struct pdp_t **pdp,
-		      uint64_t imsi, uint8_t nsapi) OSMO_DEPRECATED("Use gtp_pdp_newpdp() instead");
-extern int gtp_freepdp(struct gsn_t *gsn, struct pdp_t *pdp);
-extern int gtp_freepdp_teardown(struct gsn_t *gsn, struct pdp_t *pdp);
 
 extern int gtp_create_context_req(struct gsn_t *gsn, struct pdp_t *pdp,
 				  void *cbp);
 
-extern int gtp_set_cb_create_context_ind(struct gsn_t *gsn,
-					 int (*cb_create_context_ind) (struct
-								       pdp_t *
-								       pdp));
-
 extern int gtp_create_context_resp(struct gsn_t *gsn, struct pdp_t *pdp,
 				   int cause);
 
@@ -351,53 +262,10 @@ extern int gtp_ran_info_relay_req(struct
 				  const uint8_t *rim_route_addr, size_t rim_route_addr_len,
 				  uint8_t rim_route_addr_discr);
 
-extern int gtp_set_cb_data_ind(struct gsn_t *gsn,
-			       int (*cb_data_ind) (struct pdp_t * pdp,
-						   void *pack, unsigned len));
-
-extern int gtp_fd(struct gsn_t *gsn);
 extern int gtp_decaps0(struct gsn_t *gsn);
 extern int gtp_decaps1c(struct gsn_t *gsn);
 extern int gtp_decaps1u(struct gsn_t *gsn);
-extern int gtp_retrans(struct gsn_t *gsn) OSMO_DEPRECATED("This API is a no-op, libgtp already does the job internally");
-extern int gtp_retranstimeout(struct gsn_t *gsn, struct timeval *timeout) OSMO_DEPRECATED("This API is a no-op and will return a 1 day timeout");
-
-extern int gtp_set_cb_delete_context(struct gsn_t *gsn,
-				     int (*cb_delete_context) (struct pdp_t *
-							       pdp));
-/*extern int gtp_set_cb_create_context(struct gsn_t *gsn,
-  int (*cb_create_context) (struct pdp_t* pdp)); */
-
-extern int gtp_set_cb_unsup_ind(struct gsn_t *gsn,
-				int (*cb) (struct sockaddr_in * peer));
-
-extern int gtp_set_cb_extheader_ind(struct gsn_t *gsn,
-				    int (*cb) (struct sockaddr_in * peer));
-
-extern int gtp_set_cb_ran_info_relay_ind(struct gsn_t *gsn,
-				    int (*cb) (struct sockaddr_in * peer, union gtpie_member **ie));
-
-extern int gtp_set_cb_conf(struct gsn_t *gsn,
-			   int (*cb) (int type, int cause, struct pdp_t * pdp,
-				      void *cbp));
-
-int gtp_set_cb_recovery(struct gsn_t *gsn,
-			int (*cb) (struct sockaddr_in * peer,
-				   uint8_t recovery))
-	OSMO_DEPRECATED("Use gtp_set_cb_recovery2() instead, to obtain pdp ctx originating the recovery");
-int gtp_set_cb_recovery2(struct gsn_t *gsn,
-			int (*cb) (struct sockaddr_in * peer,
-				   struct pdp_t * pdp,
-				   uint8_t recovery))
-	OSMO_DEPRECATED("Use gtp_set_cb_recovery3() instead, to obtain gsn handling the recovery");;
-int gtp_set_cb_recovery3(struct gsn_t *gsn,
-			int (*cb) (struct gsn_t * gsn, struct sockaddr_in * peer,
-				   struct pdp_t * pdp,
-				   uint8_t recovery));
-
-void gtp_clear_queues(struct gsn_t *gsn);
-
-/* Internal functions (not part of the API */
+/* Internal functions (not part of the API) */
 
 extern int gtp_echo_req(struct gsn_t *gsn, int version, void *cbp,
 			struct in_addr *inetaddrs);
diff -pruN 1.9.0-3.1/lib/Makefile.am 1.11.0-1/lib/Makefile.am
--- 1.9.0-3.1/lib/Makefile.am	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/lib/Makefile.am	2023-11-28 13:07:17.000000000 +0000
@@ -2,7 +2,7 @@ noinst_LIBRARIES = libmisc.a
 
 noinst_HEADERS = gnugetopt.h ippool.h lookup.h syserr.h tun.h in46_addr.h netdev.h gtp-kernel.h netns.h util.h icmpv6.h checksum.h
 
-AM_CFLAGS = -O2 -fno-builtin -Wall -DSBINDIR='"$(sbindir)"' -ggdb $(LIBOSMOCORE_CFLAGS)
+AM_CFLAGS = -fno-builtin -Wall -DSBINDIR='"$(sbindir)"' $(LIBOSMOCORE_CFLAGS)
 
 libmisc_a_SOURCES = getopt1.c getopt.c ippool.c lookup.c tun.c debug.c in46_addr.c netdev.c netns.c util.c icmpv6.c checksum.c
 
diff -pruN 1.9.0-3.1/lib/icmpv6.h 1.11.0-1/lib/icmpv6.h
--- 1.9.0-3.1/lib/icmpv6.h	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/lib/icmpv6.h	2023-11-28 13:07:17.000000000 +0000
@@ -44,10 +44,9 @@ struct icmpv6_radv_hdr {
 	uint8_t res:6,
 		m:1,
 		o:1;
-#else
-	uint8_t m:1,
-		o:1,
-		res:6;
+#elif OSMO_IS_BIG_ENDIAN
+/* auto-generated from the little endian part above (libosmocore/contrib/struct_endianness.py) */
+	uint8_t o:1, m:1, res:6;
 #endif
 	uint16_t router_lifetime;
 	uint32_t reachable_time;
@@ -72,10 +71,9 @@ struct icmpv6_opt_prefix {
 	uint8_t res:6,
 		a:1,
 		l:1;
-#else
-	uint8_t l:1,
-		a:1,
-		res:6;
+#elif OSMO_IS_BIG_ENDIAN
+/* auto-generated from the little endian part above (libosmocore/contrib/struct_endianness.py) */
+	uint8_t l:1, a:1, res:6;
 #endif
 	uint32_t valid_lifetime;
 	uint32_t preferred_lifetime;
diff -pruN 1.9.0-3.1/lib/in46_addr.c 1.11.0-1/lib/in46_addr.c
--- 1.9.0-3.1/lib/in46_addr.c	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/lib/in46_addr.c	2023-11-28 13:07:17.000000000 +0000
@@ -375,3 +375,10 @@ default_to_dyn_v4:
 	dst->v4.s_addr = 0;
 	return 1;
 }
+
+void in46a_from_gsna(const struct ul16_t *in, struct in46_addr *dst)
+{
+	dst->len = in->l;
+	OSMO_ASSERT(in->l <= sizeof(dst->v6));
+	memcpy(&dst->v6, in->v, in->l);
+}
diff -pruN 1.9.0-3.1/lib/in46_addr.h 1.11.0-1/lib/in46_addr.h
--- 1.9.0-3.1/lib/in46_addr.h	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/lib/in46_addr.h	2023-11-28 13:07:17.000000000 +0000
@@ -39,3 +39,5 @@ static inline bool in46a_is_v6(const str
 static inline bool in46a_is_v4(const struct in46_addr *addr) {
 	return addr->len == sizeof(struct in_addr);
 }
+
+void in46a_from_gsna(const struct ul16_t *in, struct in46_addr *dst);
diff -pruN 1.9.0-3.1/sgsnemu/Makefile.am 1.11.0-1/sgsnemu/Makefile.am
--- 1.9.0-3.1/sgsnemu/Makefile.am	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/sgsnemu/Makefile.am	2023-11-28 13:07:17.000000000 +0000
@@ -2,7 +2,7 @@ bin_PROGRAMS = sgsnemu
 
 AM_LDFLAGS = @EXEC_LDFLAGS@
 
-AM_CFLAGS = -O2 -D_GNU_SOURCE -fno-builtin -Wall -DSBINDIR='"$(sbindir)"' -ggdb $(LIBOSMOCORE_CFLAGS)
+AM_CFLAGS = -D_GNU_SOURCE -fno-builtin -Wall -DSBINDIR='"$(sbindir)"' $(LIBOSMOCORE_CFLAGS)
 
 sgsnemu_LDADD = @EXEC_LDADD@ -lgtp -L../gtp ../lib/libmisc.a $(LIBOSMOCORE_LIBS)
 
diff -pruN 1.9.0-3.1/tests/gtp/Makefile.am 1.11.0-1/tests/gtp/Makefile.am
--- 1.9.0-3.1/tests/gtp/Makefile.am	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/tests/gtp/Makefile.am	2023-11-28 13:07:17.000000000 +0000
@@ -1,4 +1,5 @@
-AM_CFLAGS = -Wall -I$(top_srcdir)/include $(LIBOSMOCORE_CFLAGS) -g
+AM_CFLAGS = -Wall -I$(top_srcdir)/include $(LIBOSMOCORE_CFLAGS)
+AM_LDFLAGS = -no-install
 
 EXTRA_DIST = \
 	gtpie_test.ok \
diff -pruN 1.9.0-3.1/tests/lib/Makefile.am 1.11.0-1/tests/lib/Makefile.am
--- 1.9.0-3.1/tests/lib/Makefile.am	2022-06-28 15:48:22.000000000 +0000
+++ 1.11.0-1/tests/lib/Makefile.am	2023-11-28 13:07:17.000000000 +0000
@@ -1,4 +1,5 @@
-AM_CFLAGS = -Wall -I$(top_srcdir)/include $(LIBOSMOCORE_CFLAGS) -g
+AM_CFLAGS = -Wall -I$(top_srcdir)/include $(LIBOSMOCORE_CFLAGS)
+AM_LDFLAGS = -no-install
 
 EXTRA_DIST = ippool_test.ok \
 	     ippool_test.err \
